DECLARE SUB KillFile (A$)
Declare SUB PressToContinue ()
DECLARE FUNCTION Shrink$ (In$)
DECLARE SUB AlphaDir (DestDisk$)

' Import to TI99-PC image format a selection of DOS files
' Create a TI99-PC image file and transfer all selected files to it.
'
' - Paolo Bagnaresi, May 2001 - e-mail: paul.bagnaresi@gmail.com 
'
' This module can be Launched with a CHAIN qbasic instruction by a different qbasic program.
' Just add the same COMMON arrays to your launcher. (DIM Vector, MyName$, MyVal and the 3 corresponding COMMON Shared declarations).
' These arrays are used only as a parameter passing between chained qbasic programs.
DECLARE SUB ShowHex (A$, K$)
DECLARE SUB Fischio ()
DECLARE SUB ERRSOUND ()
DECLARE FUNCTION CalcWord% (A$, P%)
DECLARE SUB ThisHelp (Banner$, DatFile$, IDXFile$, Argum$)
DECLARE SUB box (Y%, X%, W%, H%)
Dim Vector(0 TO 10)      AS INTEGER
DIM MyName$(0 TO 30)
DIM MyVal(0 TO 10)      AS INTEGER

COMMON SHARED Vector() AS INTEGER
COMMON SHARED MyName$()
COMMON SHARED MyVal() AS INTEGER
Dim Shared FilErrFlg As Integer
DEFINT A-Z
                
' DIM DiskSize(1 TO 16)  AS INTEGER    ' Sectors per Disk. 360, 720, 1440, 2880
' DIM SecTrack(1 TO 16)  AS INTEGER    ' Sector per Track. 9 or 18
' DIM TrackSide(1 TO 16)  AS INTEGER   ' Track/side 40 or 80
' DIM NumSides(1 TO 16)  AS INTEGER    ' Number of Sides. 1= Single Side, 2=Double Side
' DIM DskDens(1 TO 16)  AS INTEGER     ' Disk Density. 1=Single Density, 2=Double Density
' DIM LowestSect(1 TO 16)  AS INTEGER  ' Lowest sector where to begin to copy Data Sectors
' DIM UpperABM(1 TO 16)  AS INTEGER    ' Highest byte in Allocation Bit Map in sector zero
' DIM SectAU(1 TO 16)  AS INTEGER      ' How many sectors per Allocation Unit
' 
        DIM DriveParms(0 TO 16)  AS STRING * 6   ' Drive Parameters: Disk Size (2 bytes);Sec/Track (1); Track/Side (1); NSides(1);Density (1)
        ' Drive Parameters:        Disk Size (2 bytes);          Sec/Track (1); Track/Side (1); NSides(1);Density (1)           
        DriveParms(1)=CHR$(INT(360 / 256)) + CHR$(360 MOD 256)   +  CHR$(9)     + CHR$(40)         + CHR$(1)    + CHR$(1)
        DriveParms(2)=CHR$(INT(720 / 256)) + CHR$(720 MOD 256)   +  CHR$(9)     + CHR$(40)         + CHR$(2)    + CHR$(1)
        DriveParms(3)=CHR$(INT(720 / 256)) + CHR$(720 MOD 256)   +  CHR$(18)    + CHR$(40)         + CHR$(1)    + CHR$(2)
        DriveParms(4)=CHR$(INT(1440/ 256)) + CHR$(1440 MOD 256)  +  CHR$(18)    + CHR$(40)         + CHR$(2)    + CHR$(2)
        DriveParms(5)=CHR$(INT(1440/ 256)) + CHR$(1440 MOD 256)  +  CHR$(36)    + CHR$(40)         + CHR$(1)    + CHR$(3)
        DriveParms(6)=CHR$(INT(2880/ 256)) + CHR$(2880 MOD 256)  +  CHR$(36)    + CHR$(40)         + CHR$(2)    + CHR$(3)
        DriveParms(7)=CHR$(INT(2880/ 256)) + CHR$(2880 MOD 256)  +  CHR$(72)    + CHR$(40)         + CHR$(1)    + CHR$(4)
        DriveParms(8)=CHR$(INT(5760/ 256)) + CHR$(5760 MOD 256)  +  CHR$(72)    + CHR$(40)         + CHR$(2)    + CHR$(4)
        DriveParms(9)=CHR$(INT(720/ 256)) + CHR$(720  MOD 256)   +  CHR$(9)     + CHR$(80)         + CHR$(1)    + CHR$(1)
        DriveParms(10)=CHR$(INT(1440/ 256)) + CHR$(1440 MOD 256) +  CHR$(9)     + CHR$(80)         + CHR$(2)    + CHR$(1)
        DriveParms(11)=CHR$(INT(1440/ 256)) + CHR$(1440 MOD 256) +  CHR$(18)    + CHR$(80)         + CHR$(1)    + CHR$(2)
        DriveParms(12)=CHR$(INT(2880/ 256)) + CHR$(2880 MOD 256) +  CHR$(18)    + CHR$(80)         + CHR$(2)    + CHR$(2)
        DriveParms(13)=CHR$(INT(2880/ 256)) + CHR$(2880 MOD 256) +  CHR$(36)    + CHR$(80)         + CHR$(1)    + CHR$(3)
        DriveParms(14)=CHR$(INT(5760/ 256)) + CHR$(5760 MOD 256) +  CHR$(36)    + CHR$(80)         + CHR$(2)    + CHR$(3)
        DriveParms(15)=CHR$(INT(5760/ 256)) + CHR$(5760 MOD 256) +  CHR$(72)    + CHR$(80)         + CHR$(1)    + CHR$(4)
        DriveParms(16)=CHR$(INT(11520/ 256)) + CHR$(11520 MOD 256)+ CHR$(72)    + CHR$(80)         + CHR$(2)    + CHR$(4)               

        DIM TmpRec AS STRING * 256           ' Temporary string to read a sector from a Binary file

                                        
        DummyRec$ = STRING$(256, CHR$(&HE5))
                
DEFINT A-Z
                TYPE IDXType
                Section AS STRING * 20
                StartRec AS DOUBLE
                RecLength AS SINGLE
                END TYPE
                DIM SHARED IDXRecord AS IDXType
                

' Structure of RECORD 1 (96 bytes) in "Selected$" file
'+----------------+----------------+----------------+----------------+----------------+
'|  byte  1-20    |  byte  21-40   |  byte  41-60   |  byte  61-80   |  byte  81-104  |
'+----------------+----------------+----------------+----------------+----------------+
'|Pointer to Last | Total FILES    | Total SIZE     |     Total      |    Dummy       |
'| Used record    |                |                |  Directories   |    Field       |
'| as plain ASCII | as plain ASCII | as plain ASCII | as plain ASCII |                |
'+----------------+----------------+----------------+----------------+----------------+
'|  PntLastUsed%  | TotFiles2Copy% | TotSize2Copy&  |   TotDirs%     |                |
'|     Pntr       |      TFIL      |     TSIZ      |       TDir      |                |
'+----------------+----------------+----------------+----------------+----------------+

' Structure of Other Records (96 bytes) in "Selected$" file
'+----------------+----------------+-------+-------+-------+-------+-------+----------------+-----------+
'|  byte  1       |  byte  2-80    |   81  |   82  |   83  |   84  |   85  |  byte  86-96   | 97-104    |
'+----------------+----------------+---------------------------------------+----------------+-----------+
'| Field Length=1 |      79        |    1  |    1  |    1  |    1  |    1  |       11       |    8      |
'+----------------+----------------+---------------------------------------+----------------+-----------+
'|   Copy Mark    |  DOS Filename  | File  | File  |  ARK  |Unused |Unused |   TI Filename  | TIFILES   |
'| as plain ASCII | as plain ASCII | Type  | Length|SubFile|       |       |                | Info Area |
'+----------------+----------------+-------+-------+-------+-------+-------+----------------+-----------+
'|  CpyMark       |       SL       | DTyp  | DLen  | DArk  | DFre1 | DFre2 |   TINAME       |   TifAr   |
'+----------------+----------------+-------+-------+-------+-------+-------+----------------+-----------+

' CpyMark = C,X,T or 0-9. C=Copy; X=UnArk an Ark file, T=TIFILES file. Reflects the user's choice
' DArk    = Blank, K, T.  X=ARK Sub File, that is a TI file contained in an ARK or TIFILES Structure.
'                         Blank = Current File is not an Ark Subfile. T=Add this file as from Sel.TifAr info,
'                         since it kept the original TI structure; because of the mess around TIFILES structure, 
'                         only TI99-PC TIG files will be accepted. Reflects TI99-PC findings
' DTyp    = P=PROGRAM, V=DIS/VAR, F=DIS/FIX, v=INT/VAR, f=INT/FIX, TI File Type

' May 2008 - Long Filenames Fix. Field "SL" (79 bytes) will no longer store the (almost) entire row returned by
'            the DOS DIR command. Rather, it will be ideally divided into two fields (although it will
'            physically remain just one field).
'            The first field (byte 2-45, 44 bytes long) will store the Filename (Short or Long). If a LongFilename exceeds
'            the 59 byte length limit, the corresponding ShortFilename will be stored.
'            The second field (byte 61-80, 20 bytes long) will store the file size. Finally, since TAB key (Call ViewChosen)
'            will show just the first 72 bytes of SL field anyway (and this due to screen size costrains, just 80 columns),
'            byte 73-80 will not be used or displayed. This means that only the first 13 bytes of FileLength field
'            will be used and displayed.
'            Directories ("<DIR<") and Ark files ("<ARK") will not have File Length.       
'
'            +-------------------------------------------------+
'            |            byte  2-80 (79 bytes long)           |
'            +---------------------------------+---------------+
'            |    byte 2-60 (44 bytes long)    | byte 61-80    |
'            +---------------------------------+---------------+
'            |  Long Filename  as plain ASCII  |  FileLength   |
'            +---------------------------------+---------------+
'                                            SL field
' August 2008 - Added TifAr = TIFILES descriptor Area. 8 bytes, exact copy of bytes 13-19 in TI FDR (byte 1 being first byte)

                
                TYPE FHead
                Pntr AS STRING * 20
                TFIL AS STRING * 20
                TSIZ AS STRING * 20
                TDir AS STRING * 20
                Noth AS STRING * 16
                END TYPE
                DIM SHARED FiHeader AS FHead
                
                TYPE SelecType
                CpyMark AS STRING * 1
                SL AS STRING * 79
                DTyp AS STRING * 1
                DLen AS STRING * 1
                Dark AS STRING * 1
                DFre1 AS STRING * 1
                DFre2 AS STRING * 1
                TINAME AS STRING * 11
                TifAr  AS STRING * 8
                END TYPE
                DIM SHARED Sel AS SelecType
                
                
                
                CLS
                SourcePath$ = MyName$(3)
                DestinPath$ = MyName$(5)
                FirstDestinPath$ = DestinPath$
' Get filename 
                FOR T% = LEN(DestinPath$) TO 1 STEP -1
                T$ = MID$(DestinPath$, T%, 1): IF T$ = "\" THEN A$ = (RIGHT$(DestinPath$, LEN(DestinPath$) - T%)): GOTO DskNFound
                NEXT T%
                A$ = DestinPath$
DskNFound:      A$ = RTRIM$(LTRIM$(A$))
                
' Do away with extension
                FOR T% = 1 TO LEN(A$)
                T$ = MID$(A$, T%, 1): IF T$ = "." THEN DskName$ = (LEFT$(A$, T% - 1)): GOTO DsknameFound
                NEXT T%
                DskName$ = A$
DsknameFound:   DskName$ = RTRIM$(LTRIM$(DskName$))
                IF LEN(DskName$) > 8 THEN DskName$ = LEFT$(DskName$, 8)
                FOR T% = 1 TO LEN(DskName$)
                T$ = MID$(DskName$, T%, 1): IF T$ = " " THEN MID$(DskName$, T%) = "-"
                NEXT T
                
                
                REDIM FilName$(1)
                IF DestinPath$ = "" THEN DestinPath$ = SourcePath$: MID$(DestinPath$, LEN(DestinPath$), 1) = "1"
                Incr% = 1  ' File Output number
                GOTO OpenFile

' Exit point with F9
Abort:          'MyName$(2) = ""
                GOTO LeaveIt2

Leaveit:        'MyName$(2) = SourcePath$
LeaveIt2:       ERASE FilName$
                CLOSE #1
                CLOSE #2
                CLOSE #5
        
                CHAIN MyName$(0)

OpenFile:
                
                
                
                Selected$ = "~DOS2IB.TMP"
                ' OPEN Selected$ FOR RANDOM ACCESS READ AS #5 LEN = LEN(Sel)
                GET #5, 1, FiHeader
                PntLastUsed% = VAL(FiHeader.Pntr)
                TotFiles2Copy% = VAL(FiHeader.TFIL)
                TotSize2Copy& = VAL(FiHeader.TSIZ)
                TotDirs% = VAL(FiHeader.TDir)
                IF TotFiles2Copy% = 0 THEN GOTO Leaveit
                TFNames% = TotFiles2Copy%
                

'==========================
' COPY DISK STARTS HERE
'==========================

StartCopying:
                CALL box(1, 1, 80, 24)

                IF MyVal(1) <> 0 THEN BEEP
                LOCATE 2, 28: PRINT "AVAILABLE DISK SIZES"
                LOCATE 4, 3: PRINT " 1)   90K  - SSSD   -  360 sectors -  9 sctr/trk - 40 tracks"
                COLOR 14, 0
                LOCATE 5, 3: PRINT " 2)  180K  - DSSD   -  720 sectors -  9 sctr/trk - 40 tracks <"
                COLOR 7, 0
                LOCATE 6, 3: PRINT " 3)  180K  - SSDD   -  720 sectors - 18 sctr/trk - 40 tracks"
                COLOR 14, 0
                LOCATE 7, 3: PRINT " 4)  360K  - DSDD   - 1440 sectors - 18 sctr/trk - 40 tracks <"
                COLOR 7, 0
                LOCATE 8, 3: PRINT " 5)  360K  - SSHD   - 1440 sectors - 36 sctr/trk - 40 tracks"
                LOCATE 9, 3: PRINT " 6)  720K  - DSHD   - 2880 sectors - 36 sctr/trk - 40 tracks"
                COLOR 12, 0
                LOCATE 10, 3: PRINT " 7)  720K  - SSED   - 2880 sectors - 72 sctr/trk - 40 tracks ?"
                LOCATE 11, 3: PRINT " 8) 1440K  - DSED   - 5760 sectors - 72 sctr/trk - 40 tracks ?"
                COLOR 7, 0

                LOCATE 13, 3: PRINT " 9)  180K  - SSSD   -  720 sectors -  9 sctr/trk - 80 tracks"
                LOCATE 14, 3: PRINT " A)  360K  - DSSD   - 1440 sectors -  9 sctr/trk - 80 tracks"

                LOCATE 15, 3: PRINT " B)  360K  - SSQD   - 1440 sectors - 18 sctr/trk - 80 tracks"
                LOCATE 16, 3: PRINT " C)  720K  - DSQD   - 2880 sectors - 18 sctr/trk - 80 tracks"

                LOCATE 17, 3: PRINT " D)  720K  - SSHD   - 2880 sectors - 36 sctr/trk - 80 tracks"
                LOCATE 18, 3: PRINT " E  1440K  - DSHD   - 5760 sectors - 36 sctr/trk - 80 tracks"
                COLOR 12, 0
                LOCATE 19, 3: PRINT " F) 1440K  - SSED   - 5760 sectors - 72 sctr/trk - 80 tracks ? "
                LOCATE 20, 3: PRINT " G) 2880K  - DSED   -11520 sectors - 72 sctr/trk - 80 tracks ? "
                COLOR 7, 0

UsrChoice:      COLOR 14, 0
                LOCATE 21, 4: PRINT " < marks the most common formats";
                COLOR 7, 0
                COLOR 12, 0
                LOCATE 21, 37: PRINT " ? marks a completely non standard format";
                LOCATE 22, 37: PRINT "   (IBM Perpendicular Recording, 2.88 MB)";
                COLOR 7, 0
                LOCATE 23, 6
                PRINT "Your choice: ";
                DO
                T$ = INKEY$
                LOOP UNTIL T$ <> ""
                IF T$ = CHR$(0) + CHR$(59) THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "18.04.03"): CLS : GOTO StartCopying
                IF T$ = CHR$(27) THEN GOTO Leaveit
                IF LEN(T$) > 1 THEN GOTO StartCopying
                T$=UCASE$(T$)   
                'IF INSTR("abcd", T$) > 0 THEN T$ = CHR$(ASC(RIGHT$(T$, 1)) AND (255 - 32))' Force Uppercase
                Sauce = INSTR("123456789ABCDEFG", T$)
                IF Sauce = 0 THEN GOTO StartCopying
                PRINT T$;
                
                ' March 11, 2004 V9T9$ new variable. New default is V9T9 format.
                ' IF V9T9$="" THEN do not add Error Table at the end of the file. It's useless anyway!
                ' Add some code here if you want to give the user a chance to create an IMG format file.
                
'===================
' START COPYING
'===================
StartCopying2:
                CLS
                ' Get all Filenames with vital parameters
                
'********************************=
' CURRENT FILENAME : START OF LOOP
'********************************=
                
                Skipped% = 0
                Done% = 0
                DisksRound% = 0
                FirstDisk$ = ""
                AtLeast$ = ""           
                PRINT "Importing from DOS..."
                PRINT
 
'
' FIRST OFF, WORK OUT THE NUMBER OF FILES TO BE ARKED, IF ANY
'
                FOR Itm% = 1 TO PntLastUsed% - 1
                GET #5, 1 + Itm%, Sel
                IF Sel.CpyMark = "K" THEN ARKTot% = ARKTot% + 1
                NEXT Itm%
                IF ARKTot% = 0 THEN GOTO PastToBeArked' No file to be ARKed, skip this section
                GOSUB NameDisk: GOSUB CreateDisk: : AtLeast$ = "X"  ' Create a new Disk Image File
                GOSUB ARKthese  ' ARK these files and import them
PastToBeArked:
                SEEK #5, 2      ' Reload Pointer to first record after the header record
                
' NOW, ADD ALL THE REMAINING FILES
                IF AtLeast$ = "" THEN SelStr$ = "0123456789C" ELSE SelStr$ = "C0123456789"
                        
                FOR Order% = 1 TO LEN(SelStr$)
                Tell$ = MID$(SelStr$, Order%, 1)
                
                FOR Itm% = 1 TO PntLastUsed% - 1
                GET #5, 1 + Itm%, Sel
                IF MID$(Sel.SL, 1, 4) = "<DIR" THEN CurrArk$ = "": SkpArk$="" : CurrPath$ = RTRIM$(MID$(Sel.SL, 7, LEN(Sel.SL))): GOTO NxtItm
                
                ' ARK SubFiles are listed in a unique block in ~tmpfile.tmp file. When we find an "<ARK>" entry, we have to:
                ' - 1) Open the ARK file with the DECOMP4.COM DeArchiver, and output the unzipped content to the ~tmpfile.tmp file.
                ' - 2) Each next ARK SubFile will be found on the above ~tmpfile.tmp unzipped file.
                ' - 3) As soon as we find another "<DIR>" entry, erase the CurrArk$ variable
                IF MID$(Sel.SL, 1, 4) <> "<ARK" THEN GOTO NotARKgroup
                
                'CurrArk$ = RTRIM$(MID$(Sel.SL, 7, 8)) + "." + RTRIM$(MID$(Sel.SL, 16, 3))
                CurrArk$ = Shrink(MID$(Sel.SL, 7, LEN(Sel.SL)))

                KPath$ = CurrPath$ + CurrArk$
                CALL ShortLongName(KPath$,CR$,1) ' Get Short Name out of a long filename
                
                IF FileExists(KPath$)<>0 THEN SkpArk$="Y" : GOTO NxtItm
                	
                Exec$ = "Decomp4.com " + KPath$ + " ~tmpfile.tmp >NULL"
                SHELL Exec$
                GOTO NxtItm
                
                
NotARKgroup:    IF Sel.CpyMark = "T" AND Tell$ = "C" THEN GOTO TrimFIFILES
                IF Sel.Dark = "X" AND Tell$ = "C" THEN GOTO ARKFile
                IF Sel.CpyMark <> Tell$ THEN GOTO NxtItm
                GOTO NormalFile
                
' ARK File           
ARKFile:        IF SkpArk$<>"" 	OR Sel.CpyMark="N" THEN GOTO NxtItm
		SArkFilName$ = MID$(Sel.SL, 1, 10)
                
                GOSUB TxferThisArk
                GOTO NxtItm

' Trim TIFILES Header. "T" command key files will be processed at the same time of "C" command key files
                
TrimFIFILES:    TIF$ = CurrPath$ + Shrink(LEFT$(Sel.SL, 44))
                TIF2$ = TIF$: CALL ShortLongName(TIF2$,CR$,1) ' Get Short Name out of a long filename
                PRINT TIF$; " as "; LEFT$(Sel.TINAME, 10)   ' Filename
                IF Sel.DArk = "T" THEN FullFile$=TIF2$ : GOTO  TrimFIFILES1 ' A true TI99-PC file? Yes, jump
                Exec$ = "Decomp4.com  " + TIF2$ + " ~tmpfile.tmp /T >NULL"
                SHELL Exec$
                FullFile$ = "~tmpfile.tmp"
                GOTO NormalFile22

' "T" - a true TI99-PC TIFILES file here                
TrimFIFILES1: 
                OPEN FullFile$ FOR BINARY ACCESS READ SHARED AS #7
                GOSUB OpenTempFile ' (File #1, "~tmpfil.tmp")
                BytePos&=1
                Offset1&=128
                Offset2&=256
                WHILE NOT EOF(7)
                GET #7, BytePos&+ Offset1&,TmpRec 
                PUT #1, BytePos& + Offset2&, TmpRec
                BytePos& = BytePos& + 256
                WEND 
                     
                CLOSE # 7
                OutSect$ = STRING$(256, CHR$(0))
                MID$(OutSect$, 1)=LEFT$(Sel.TINAME,10)
                MID$(OutSect$, 13) = Sel.TifAr
               
                PUT #1, 1, OutSect$
                CLOSE #1 
             
                GOSUB Add2Image
                Done% = Done% + 1
                GOTO  NxtItm
                                
' Normal File; 0-9, C
NormalFile:     FullFile$ = CurrPath$ + Shrink(LEFT$(Sel.SL, 44))
                PRINT FullFile$; " as "; LEFT$(Sel.TINAME, 10);    ' Filename
NormalFile22:   Call ShortLongName(FullFile$,CR$,1) ' Get Short Name out of a long filename
                GOSUB TxferThisFile : If SkpThis$<>"" Then Print " -> File not found!" :Skipped% = Skipped% + 1: GoTo NormalFile33 Else Print ""
                
                GOSUB Add2Image
NormalFile33:   Done% = Done% + 1
NxtItm:    
                NEXT Itm%
                
                IF AtLeast$ <> "" THEN GOSUB CloseOutput: AtLeast$ = ""
                NEXT Order%
StopIt:
                
'******************************=
' CURRENT FILENAME : END OF LOOP
'******************************=

                PRINT
                PRINT "=      WHAT HAPPENED       ="
                IF ARKDone% > 0 THEN
                PRINT "- Total Arked Files        :"; ARKDone%
                PRINT "- Total ARK Sector Size    :"; ARKGlobalSectors
                END IF
                PRINT "- Total Files Added (TFA)  :"; Done% - Skipped%
                PRINT "- Sector Size of TFA       :"; GlobalSectors#
                PRINT "- Total Files Skipped      :"; Skipped%
                PRINT "- Total Disks              :"; DisksRound%
                PRINT "- Disk Size (Sectors)      :"; DiskSize%
                PRINT "- First Disk name          : "; FirstDestinPath$
                PRINT "- Last  Disk name          : "; DestinPath$
                PRINT
                PRINT "Press any key to continue"
                CopiedDirs$(ChosenDir%) = "Y"
                DO
                K$ = INKEY$
                LOOP UNTIL K$ <> ""
                CLS
                
                GOTO Leaveit

' *******************************            
' ARK these files and import them            
' *******************************
ARKthese:    
' NEXT, CREATE THE ARK FILE
                
                SEEK #5, 2      ' Reload Pointer to first record after the header record
                
                CrArkFilName$ = "~2Barked.ARK" ' Our Temporary ARK file
                FOR Itm% = 1 TO PntLastUsed% - 1
                GET #5, 1 + Itm%, Sel
                IF MID$(Sel.SL, 1, 4) = "<DIR" THEN CurrArk$ = "": CurrPath$ = RTRIM$(MID$(Sel.SL, 7, LEN(Sel.SL))): GOTO NotToBeArked
                IF Sel.CpyMark <> "K" THEN GOTO NotToBeArked
                IF OutArkFile$="Y" THEN GOTO ToBeArked
                

                GOSUB CreateArkFile             ' Open Temporary Output File as #8
                
ToBeArked:      'FullFile$ = CurrPath$ + RTRIM$(MID$(Sel.SL, 1, 8)) + "." + RTRIM$(MID$(Sel.SL, 10, 3))
                FullFile$ = CurrPath$ + Shrink(LEFT$(Sel.SL, 44))
                PRINT FullFile$; " ("; RTRIM$(MID$(Sel.SL, 45, 23)); ")"; " as "; LEFT$(Sel.TINAME, 10);  ' Filename
                GOSUB TxferThisFile             ' Create a TI file sector image, no FDR yet
                If SkpThis$<>"" Then Print " -> File not found!" : GoTo NotToBeArked Else Print "" 
                OPEN TmpFilName$ FOR RANDOM ACCESS READ AS #1 LEN = 256
                FIELD #1, 256 AS d$
                GET #1, 1
                FHeader$ = d$
                A$ = MID$(FHeader$, 1, 10)     ' Filename
                A$ = A$ + MID$(FHeader$, 13, 1)' Byte  13    (byte 1=first) = FileType
                A$ = A$ + MID$(FHeader$, 14, 1)' Byte  14    (byte 1=first) = Max. numb. of records/sector or AU
                A$ = A$ + MID$(FHeader$, 15, 2)' Bytes 15,16 (byte 1=first) = Filelength, reversed bytes
                A$ = A$ + MID$(FHeader$, 17, 1)' Byte  17    (byte 1=first) = End of file Offset
                A$ = A$ + MID$(FHeader$, 18, 1)' Byte  18    (byte 1=first) = Logical record Length
                A$ = A$ + MID$(FHeader$, 19, 2)' Bytes 19,20 (byte 1=first) = Number of Fixed Length Record -OR- Number of Sectors used by variable Length Records
                
                PUT #8, HeaderPos%, A$: HeaderPos% = HeaderPos% + 18
                CreatedArk% = CreatedArk% + 1: IF CreatedArk% MOD 14 = 0 THEN HeaderPos% = HeaderPos% + 4
                TmpFileSects% = CalcWord(FHeader$, 15)
                FOR T = 1 TO TmpFileSects%
                GET #1
                PUT #8, ArkBytePos&, d$: ArkBytePos& = ArkBytePos& + 256
                NEXT T
                CLOSE #1
                ARKDone% = ARKDone% + 1
NotToBeArked:   NEXT Itm%
                DONE% = DONE% + 1
' GET THE TI FILENAME THE USER CHOSE IN DOS2I2.BAS           
                
                OPEN "ARKNAME.DEF" FOR INPUT AS #99   ' Avoid creation of file is file doesn't exist
                LINE INPUT #99, TIArkFilName$
                LINE INPUT #99, Compression$
                CLOSE #99

' COMPRESS ARK FILE, IF REQUIRED
                
                IF Compression$ <> "C" THEN GOTO AddFDRsector
                CLOSE #8
                
                A$ = MyName$(1) + "~4Barked.ARK"' New Filename
                B$ = MyName$(1) + CrArkFilName$ ' Old filename
                CALL ShortLongName(A$,CR$,1) ' Get Short Name out of a long filename
                CALL ShortLongName(B$,CR$,1) ' Get Short Name out of a long filename
                CALL KillFile(A$)               ' Make sure we don't already have an old file with that name
                
                NAME B$ AS A$                   ' "~2Barked.ARK" becomes "~4Barked.ARK"
                
                Exec$ = "Comp2.com " + A$ + " " + B$ + " >NULL" ' Create "~2Barked.ARK", COMPRESSED
                SHELL Exec$
                
                'CALL KillFile(CrArkFilName$)   ' Make sure to Delete the temp file, if any
                OPEN CrArkFilName$ FOR BINARY ACCESS READ AS #8
                ArkBytePos& = LOF(8)            ' New Length of Ark File

                
' CREATE FDR SECTOR
AddFDRsector:
                OutSect$ = STRING$(256, CHR$(0))
                MID$(OutSect$, 1) = LEFT$(TIArkFilName$, 10)' Filename
                TtSect& = INT((ArkBytePos& / 256))
                IF ArkBytePos& MOD 256 > 0 THEN TtSect& = TtSect& + 1
                ARKGlobalSectors = TtSect& + 1          ' We can do this because "K" files are processed first
                
                B1% = INT(TtSect& / 256)
                B2% = TtSect& - (B1% * 256)
                MID$(OutSect$, 15) = CHR$(B1%) + CHR$(B2%)' Byte 14-15 = Status Flag
                TotRec% = INT(ArkBytePos& / 128)
                IF ArkBytePos& MOD 128 > 0 THEN TotRec% = TotRec% + 1
                SELECT CASE Compression$
                
                CASE "U"       ' DIS FIX
                MID$(OutSect$, 13) = CHR$(&H0)          ' Byte 12 = Status Flag
                MID$(OutSect$, 14) = CHR$(2)            ' Byte 13 = Maximum # of Records or AU
                MID$(OutSect$, 18) = CHR$(128)          ' Byte 17 = Logical Record Length
                B1% = INT(TotRec% / 256): B2% = TotRec% - (B1% * 256)
                MID$(OutSect$, 19) = CHR$(B2%) + CHR$(B1%)' Byte 18-19 = Number of Fixed Length Records
                
                CASE "C"       ' INT FIX
                MID$(OutSect$, 13) = CHR$(&H2)          ' Byte 12 = Status Flag
                MID$(OutSect$, 14) = CHR$(2)            ' Byte 13 = Maximum # of Records or AU
                MID$(OutSect$, 18) = CHR$(128)          ' Byte 17 = Logical Record Length
                B1% = INT(TotRec% / 256): B2% = TotRec% - (B1% * 256)
                MID$(OutSect$, 19) = CHR$(B2%) + CHR$(B1%)' Byte 18-19 = Number of Fixed Length Records
                END SELECT

' COPY ARK FILE TO A NEW FILE, THIS TIME WITH FDR SECTOR.
                TmpFilName$ = "~tmpfil.tmp"
                
                OPEN TmpFilName$ FOR RANDOM ACCESS WRITE AS #1 LEN = 256
                BytePos& = 1
                FIELD #1, 256 AS d$
                LSET d$ = OutSect$
                PUT #1, 1
                
                FOR T = 1 TO TtSect&
                
                GET #8, BytePos&, TmpRec: BytePos& = BytePos& + 256
                
                LSET d$ = TmpRec

                PUT #1, T + 1
                NEXT T
                CLOSE #8
                CLOSE #1

' ADD TO FINAL DISK IMAGE FILE
                TmpFileSects% = TtSect&
                GOSUB Add2Image
                DONE% = DONE% + 1
                RETURN

'*************************
' TRANSFER THE ARK SUBFILE
'*************************
TxferThisArk:   TmpFilName$ = "~tmpfil.tmp"
                CALL KillFile(TmpFilName$)
                ' Make sure to Delete the temp file, if any
                
                OPEN TmpFilName$ FOR BINARY ACCESS WRITE AS #1
                
                TmpFileSects% = 0' Count of Temporary File Sectors
                OutSect$ = ""
                OutLen% = 0
                BytePos& = 1  ' Start of TmpFilName$
                TotRec% = 0
                ' Now search the SubArk file inside the Ark File. Logic:
                ' - 1) Read the first filename. Get sector count in SArkSektCnt. Compare to our filename.
                '      Match?
                ' - 2) No, add Store sector count to Sectors2Skip accumulator and process next filename
                ' - 3) Yes, Save Filename to first >100 bytes (FDR) of TmpFilName$ output file.
                ' - 4) Add all the FDR info (reclen, file record count, etc) and replace the file type
                '      with the one chosen by user
                ' - 5) Go and find the "END!" string (End Of Filename Table Marker).
                ' - 6) From End Of Table Marker skip as many sectors as those counted in in Sectors2Skip
                ' - 7) Now, transfer as many sectors as those in SArkSektCnt to TmpFilName$ output file
                ' - 8) We're done
                OPEN "~tmpfile.tmp" FOR RANDOM ACCESS READ AS #7 LEN = 256
                Sectors2Skip = 0: ArkRecord = 0
                FIELD #7, 256 AS d$
                ' Search Filename in SubArkFile
                WHILE NOT EOF(7)
                ArkRecord = ArkRecord + 1
                GET #7, ArkRecord
                FOR T = 1 TO 14 * 18 STEP 18
                
                TmpFileSects% = CalcWord(d$, T + 12)
                
                IF MID$(d$, T, 10) = SArkFilName$ THEN GOTO TxferArk10
                Sectors2Skip = Sectors2Skip + TmpFileSects%
                NEXT T
                WEND
                GOTO TxferArk40
                
TxferArk10:   ' Transfer FDR
                A$ = LEFT$(Sel.TINAME, 10)       ' >00->09 = Filename
                A$ = A$ + STRING$(2, CHR$(0))   ' >0A->0B = 2 Bytes Reserved for Future Expansion
                A$ = A$ + MID$(d$, T + 10, 1)   ' >0C     = Filetype
                A$ = A$ + MID$(d$, T + 11, 1)   ' >0D     = Maximum Number of Records per Sector or AU
                A$ = A$ + MID$(d$, T + 12, 2)   ' >0E->0F = Total Number of Sectors Used
                A$ = A$ + MID$(d$, T + 14, 1)   ' >10     = End of File Offset
                A$ = A$ + MID$(d$, T + 15, 1)   ' >11     = Logical Record Length
                A$ = A$ + MID$(d$, T + 16, 2)   ' >12->13 = Number of Fixed Length Records or
                A$ = A$ + STRING$(236, CHR$(0)) ' >14->FF = Pad the FDR record with zeroes

                PUT #1, BytePos&, A$: BytePos& = BytePos& + 256
                ' Search the first sector with Data (first sector after "END!" End of File Table Marker)
                IF MID$(d$, 253, 4) = "END!" THEN GOTO TxferArk20
                WHILE NOT EOF(7)
                GET #7: ArkRecord = ArkRecord + 1
                IF MID$(d$, 253, 4) = "END!" THEN GOTO TxferArk20
                WEND
                PRINT : PRINT "Error. END! (End of Files Marker) not found for SubArk File " + SArkFilName$ + "  inside " + CurrArk$ + " ARK file!": INPUT ccc$
                GOTO TxferArk60

TxferArk20:   ' Actually extract SubArkFile Data
                ArkRecord = ArkRecord + Sectors2Skip
                FOR T = 1 TO TmpFileSects%
                GET #7, ArkRecord + T
                PUT #1, BytePos&, d$: BytePos& = BytePos& + 256
                NEXT T
                GOTO TxferArk60

TxferArk40:     PRINT : PRINT "Error. Sub Ark File " + SArkFilName$ + " found inside " + CurrArk$ + " ARK file!": INPUT ccc$
TxferArk60:     CLOSE #7
                CLOSE #1
                PRINT FullFile$; " as "; LEFT$(Sel.TINAME, 10)   ' Filename
                GOSUB Add2Image
                DONE% = DONE% + 1
                RETURN

'            
' CREATE TEMPORARY ARK FILE
'            
CreateArkFile:  CALL KillFile(CrArkFilName$)    ' Make sure to Delete the temp file, if any
                OPEN CrArkFilName$ FOR BINARY ACCESS READ WRITE AS #8
                BytePos& = 257  ' Leave room for ARK FDR
                ' 14 Files/sector
                'Total sector needed to contain all the Filenames for this ARK file
                T = INT(ARKTot% / 14)
                IF ARKTot% MOD 14 > 0 THEN T = T + 1
                ARKHeader$ = STRING$(256 * T, CHR$(0))
                MID$(ARKHeader$, LEN(ARKHeader$) - 3) = "END!"
                PUT #8, 1, ARKHeader$
                HeaderPos% = 1
                ArkBytePos& = LEN(ARKHeader$) + 1
                OutArkFile$="Y"
                RETURN
                

'            
' OPEN TEMPORARY OUTPUT FILE
'            
OpenTempFile:   TmpFilName$ = "~tmpfil.tmp"
                CALL KillFile(TmpFilName$)      ' Make sure to Delete the temp file, if any
                OPEN TmpFilName$ FOR BINARY ACCESS WRITE AS #1
                TmpFileSects% = 0' Count of Temporary File Sectors
                OutSect$ = ""
                OutLen% = 0
                BytePos& = 257  ' Leave room for FDR
                TotRec% = 0
                RETURN
                


'*************************
' TRANSFER THE FILE
'*************************
TxferThisFile:  SkpThis$=""     ' If SkpThis<>"" then this file has been skipped     
                CALL ShortLongName(FullFile$,CR$,1) ' Get Short Name out of a long filename
                IF FileExists(FullFile$)<>0 THEN GOTO TxferThisFerr
                               
                GOSUB OpenTempFile
                SELECT CASE Sel.DTyp
                CASE "V"       ' DIS VAR
                GOSUB DisVar
                CASE "F"       ' DIS FIX
                GOSUB DisFix
                CASE "v"       ' INT VAR
                GOSUB IntVar
                CASE "f"       ' INT FIX
                GOSUB DisFix
                CASE "P"       ' PROGRAM
                GOSUB Program
                CASE ELSE
                CLOSE #1: GOTO TxferThisFend
                END SELECT
                CLOSE #7                
                CLOSE #1     
                
                GOTO TxferThisFend
                
TxferThisFerr:  SkpThis$="Y"
TxferThisFend:  
                
                RETURN
                
'===========================================================================   


'===========================================================================   
'*************************
' DIS VAR FILE TYPE
'*************************
DisVar:         OPEN FullFile$ FOR INPUT AS #7
                
                WHILE NOT EOF(7)
                LINE INPUT #7, DR$
                IF DR$ = "" THEN TIR$ = "": GOSUB Add2Sector: GOTO NextDVRec

' Chop DOS Records longer than 254 bytes
ChopMoreDV:     IF LEN(DR$) > 254 THEN TIR$ = LEFT$(DR$, 254): DR$ = RIGHT$(DR$, LEN(DR$) - 254): GOSUB Add2Sector: GOTO ChopMoreDV
                IF DR$ <> "" THEN TIR$ = DR$: GOSUB Add2Sector
                
NextDVRec:      WEND
                IF LEN(OutSect$) > 0 THEN GOSUB SaveSector
                GOSUB CreateFDR: PUT #1, 1, OutSect$
                RETURN

'***************
' ADD TO SECTOR
'***************
                
Add2Sector:     LTIR% = LEN(TIR$)
                IF LTIR% + OutLen% > 254 THEN GOSUB SaveSector' Leave room for Length Byte and >FF End Of Sector Marker
                OutSect$ = OutSect$ + CHR$(LTIR%) + TIR$
                OutLen% = LEN(OutSect$)
                TotRec% = TotRec% + 1
                RETURN
                
SaveSector:     OutSect$ = OutSect$ + CHR$(255)
                EOFilOffset% = LEN(OutSect$) - 1
                IF LEN(OutSect$) < 256 THEN OutSect$ = OutSect$ + STRING$(256 - LEN(OutSect$), CHR$(0))
                PUT #1, BytePos&, OutSect$: BytePos& = BytePos& + 256
                
                OutSect$ = ""
                OutLen% = 0
                TmpFileSects% = TmpFileSects% + 1
                RETURN
'===========================================================================   
'*************************
' INT VAR FILE TYPE
'*************************                        
IntVar:   
                OPEN FullFile$ FOR BINARY ACCESS READ AS #7
                WHILE NOT EOF(7)
                RLen$ = INPUT$(1, 7)
                IF RLen$ = "" THEN GOTO NextIVRec
                
                DR$ = INPUT$(ASC(RLen$), 7)
                
                IF DR$ = "" THEN TIR$ = "": GOSUB Add2Sector: GOTO NextIVRec

' Chop DOS Records longer than 254 bytes
ChopMoreIV:     IF LEN(DR$) > 254 THEN TIR$ = LEFT$(DR$, 254): DR$ = RIGHT$(DR$, LEN(DR$) - 254): GOSUB Add2Sector: GOTO ChopMoreIV
                IF DR$ <> "" THEN TIR$ = DR$: GOSUB Add2Sector
                
NextIVRec:      WEND
                IF LEN(OutSect$) > 0 THEN GOSUB SaveSector
                GOSUB CreateFDR: PUT #1, 1, OutSect$
                RETURN
                
'===========================================================================   
'*************************
' DIS FIX FILE TYPE
'*************************
Program:        DFLen% = 256
                GOTO DisFix1

'===========================================================================   
'*************************
' DIS FIX FILE TYPE
'*************************

DisFix:         DFLen% = ASC(Sel.DLen)
DisFix1:        
                OPEN FullFile$ FOR RANDOM ACCESS READ AS #7 LEN = DFLen%
                'Calculate number of records in the file
                FileRecs% = LOF(7) \ DFLen%

                EOFilOffset% = LOF(7) MOD 256' Used for PROGRAM file type
                FIELD #7, DFLen% AS d$
                LofModLen% = LOF(7) MOD DFLen%
                
DisFix2:        IF EOF(7) THEN GOTO DisFix4
                OutSect$ = ""
                FOR T = 1 TO INT(256 / DFLen%)
                IF EOF(7) THEN GOTO DisFix3

                'If the filesize is an even multiple of the record size,
                'check to see if we've already read all the records.
                ' Fix by "jonathan andersson" <fallout@brainwashme.com>
                ' on January 2004. Thank you Jonathan!
                IF (LofModLen% = 0) AND (TotRec% = FileRecs%) THEN GOTO DisFix4
                
                GET #7
                
                OutSect$ = OutSect$ + d$
                TotRec% = TotRec% + 1
                NEXT T
                
DisFix3:  
                IF LEN(OutSect$) < 256 THEN OutSect$ = OutSect$ + STRING$(256 - LEN(OutSect$), CHR$(0))
                
                PUT #1, BytePos&, OutSect$: BytePos& = BytePos& + 256
                TmpFileSects% = TmpFileSects% + 1
                GOTO DisFix2
DisFix4:        GOSUB CreateFDR: PUT #1, 1, OutSect$
DisFix9:        RETURN





'*****************************
' CREATE FDR FOR ANY FILE TYPE
'*****************************
                
CreateFDR:      OutSect$ = STRING$(256, CHR$(0))
                MID$(OutSect$, 1) = LEFT$(Sel.TINAME, 10)' Filename
                B1% = INT(TmpFileSects% / 256)
                B2% = TmpFileSects% - (B1% * 256)
                MID$(OutSect$, 15) = CHR$(B1%) + CHR$(B2%)' Byte 14-15 = Status Flag
                VarSectr$ = CHR$(B2%) + CHR$(B1%)
                
                SELECT CASE Sel.DTyp
                CASE "V"       ' DIS VAR
                MID$(OutSect$, 13) = CHR$(&H80)        ' Byte 12 = Status Flag
                MID$(OutSect$, 14) = CHR$(INT(256 / ASC(Sel.DLen)))' Byte 13 = Maximum # of Records or AU
                MID$(OutSect$, 17) = CHR$(EOFilOffset%)' Byte 16 = End Of File Offset
                MID$(OutSect$, 18) = CHR$(ASC(Sel.DLen))' Byte 17 = Logical Record Length
                MID$(OutSect$, 19) = VarSectr$         ' Byte 18-19 = Number of Sectors used by Variable Length Records
                
                CASE "F"       ' DIS FIX
                MID$(OutSect$, 13) = CHR$(&H0)         ' Byte 12 = Status Flag
                MID$(OutSect$, 14) = CHR$(INT(256 / ASC(Sel.DLen)))' Byte 13 = Maximum # of Records or AU
                MID$(OutSect$, 18) = CHR$(ASC(Sel.DLen))' Byte 17 = Logical Record Length
                B1% = INT(TotRec% / 256): B2% = TotRec% - (B1% * 256)
                MID$(OutSect$, 19) = CHR$(B2%) + CHR$(B1%)' Byte 18-19 = Number of Fixed Length Records
                
                CASE "v"       ' INT VAR
                MID$(OutSect$, 13) = CHR$(&H82)        ' Byte 12 = Status Flag
                MID$(OutSect$, 14) = CHR$(INT(256 / ASC(Sel.DLen)))' Byte 13 = Maximum # of Records or AU
                MID$(OutSect$, 17) = CHR$(EOFilOffset%)' Byte 16 = End Of File Offset
                MID$(OutSect$, 18) = CHR$(ASC(Sel.DLen))' Byte 17 = Logical Record Length
                MID$(OutSect$, 19) = CHR$(B1%) + CHR$(B2%)' Byte 18-19 = Number of Sectors used by Variable Length Records
                
                CASE "f"       ' INT FIX
                MID$(OutSect$, 13) = CHR$(&H2)         ' Byte 12 = Status Flag
                MID$(OutSect$, 14) = CHR$(INT(256 / ASC(Sel.DLen)))' Byte 13 = Maximum # of Records or AU
                MID$(OutSect$, 18) = CHR$(ASC(Sel.DLen))' Byte 17 = Logical Record Length
                B1% = INT(TotRec% / 256): B2% = TotRec% - (B1% * 256)
                MID$(OutSect$, 19) = CHR$(B2%) + CHR$(B1%)' Byte 18-19 = Number of Fixed Length Records
                
                CASE " "       '
                MID$(OutSect$, 13) = CHR$(&H2)         ' Byte 12 = Status Flag
                MID$(OutSect$, 14) = CHR$(INT(256 / ASC(Sel.DLen)))' Byte 13 = Maximum # of Records or AU
                MID$(OutSect$, 18) = CHR$(ASC(Sel.DLen))' Byte 17 = Logical Record Length
                
                CASE "P"       ' PROGRAM
                MID$(OutSect$, 13) = CHR$(&H1)         ' Byte 12 = Status Flag
                MID$(OutSect$, 17) = CHR$(EOFilOffset%)' Byte 16 = End Of File Offset
                END SELECT
                
                RETURN



'===========================================================================
'****************************
' ADD TEMP FILE TO DISK IMAGE
'****************************

Add2Image:      IF AtLeast$ = "" THEN GOSUB NameDisk: GOSUB CreateDisk: : AtLeast$ = "X"
        
                OPEN TmpFilName$ FOR RANDOM ACCESS READ AS #1 LEN = 256
                FIELD #1, 256 AS d$
                
ThisFileAgain:
                GET #1, 1
                FHeader$ = d$
                FOut$ = MID$(FHeader$, 1, 10)
                
                OutFDRSectr$ = d$ ' Current File Descriptor Record in Output File
                MID$(OutFDRSectr$, 29) = STRING$(228, CHR$(0))' Blank the Data Chain Pointer Block area
                FIDChain% = 29 ' Pointer to First In Data Chain Pointer Block in Output File Descriptor Record
                SectorLength# = CalcWord(FHeader$, 15) + 1
                ' The Size on disk of any TI file is given by the following formula.
                ' For any file, 1 * SectAU will be taken by FDR, the rest by file body sectors 
                SizeOnDisk#=SectAU% + (INT((SectorLength# - 1) / SectAU%) + 1) * SectAU%
                                
' FIND FREE SECTORS IN OUTPUT DISK SECTOR ZERO
                ' Check if file fits
                
                'IF SizeOnDisk# > DiskSize(TmpSize) - (2 * SectAU(TmpSize)) THEN GOTO SkipThisFile
                IF SizeOnDisk# > DiskSize% - ((SectAU% AND 1) + SectAU%) THEN GOTO SkipThisFile
                ' In a brand new disk, no files added, this is the right formula to calculate used sectors: 
                ' UsedSect = ((SectAU(TmpSize) AND 1) + SectAU(TmpSize))
                ' 1440=2, 2880=2, 5760=4, 11520=8, 23040=16, 46080=32
                IF SectorLength# - 1 > 4096  THEN GOTO SkipThisFilT ' No file can be longer than 4095 sectors.
         
                ' Global Offset in File Chain Block is just 3 nibbles, and this is 4096. 
                ' No file can be that long for a TI Floppy.
                        
                IF StillFree% - SizeOnDisk# < 0 THEN GOTO AbortThisFile
                  
                ' Get a free block (2 consecutive bytes: 1-2, 3-4, and so on ..) in sector 1
                ' File Descriptor Index Record
                FOR FDIRT% = 1 TO 254 STEP 2
                B1$ = MID$(OutSectrOne$, FDIRT%, 1): B2$ = MID$(OutSectrOne$, FDIRT% + 1, 1)
                IF ASC(B1$) = 0 AND ASC(B2$) = 0 THEN GOTO FreeEntryFound
                NEXT FDIRT%
                GOTO AbortThisFile
                
                '
FreeEntryFound: ' Also, Find a free sector for FDR (File Descriptor Record)
                ' Cmd$="B"  means Check All the Free/Used Sector Bit Map Area, starting from the beginning
                CALL GetAFreeSect(NewFDR%,DiskSize%,SectAU%,FITAU%,LowLimit%,UpperABM%,OutSectrZero$,"B", Flag$)
                IF Flag$<>"X" THEN GOTO GotFreeSec
                BEEP
                INPUT "UNKNOWN ERROR IN ALLOCATION BIT MAP IN SECTOR ZERO. ", CCC$
                GOSUB CloseOutput              'Close Output file
                GOTO GoLeaveXfer
                
GotFreeSec:   '*------- Update Sector 1
                L1$ = CHR$(INT(NewFDR% / 256)): L2$ = CHR$(NewFDR% MOD 256)
                MID$(OutSectrOne$, FDIRT%) = L1$ + L2$' Update Sector 1 (File Descriptor Index Record)
                StillFree% = StillFree% - SectAU%' Update Free sector/disk

                Z = 0                      ' Offset in Input File Chain Pointer Block
                GlobalOutOffset% = 0       ' GLOBAL Offset in Output File Chain Pointer Block
                SectorCnt% = SectorLength# - 1' Sector Length of this file
                FirstSectIDC%=0            ' First Sector In Data Chain Block. 
                                           ' FirstSectIDC%=0 only at the beginning of "~TMPFIL.TMP" Source File
                
'****************************************
' CURRENT FILENAME : START OF CHAIN BLOCK
'****************************************
                CurSec% = 2                     ' Pointer to sectors in "~TMPFIL.TMP" Source File. First sector is FDR 

                IF CurSec% > SectorLength# THEN GOTO EOThisFilePr
                GET #1, CurSec%
                
NextClusterPr:
                ' Cmd$="H" ' Check All the Free/Used Sector Bit Map Area, starting from the beginning
                CALL GetAFreeSect(NewFreeSect%,DiskSize%,SectAU%,FITAU%,LowLimit%,UpperABM%,OutSectrZero$,"H",Flag$)
                IF Flag$="X" THEN GOSUB UnexpNoSect: GOTO AbortThisFile
                StillFree%=StillFree%-SectAU% 
                If FirstSectIDC% = 0 THEN FirstSectIDC%=NewFreeSect% :  GOTO ConsSecObtaind ' First Time Only, Initialize FirstSectIDC%
                IF Flag$<>"U" THEN  GOTO ConsSecObtaind ' Flag$="U" means new sector is NOT consecutive; so, DATA CHAIN POINTER in FDR must be updated  
                Call WriteChainPointers(FIDChain%,FirstSectIDC%,DiskSize%,GlobalOutOffset%,SectAU%,OutFDRSectr$,FOut$,Flag$)
                
                FirstSectIDC% = NewFreeSect% ' Pointer to new block in File Chain Pointer Block
                
ConsSecObtaind: LSET DataSec$ = d$
                PUT #2, NewFreeSect% + 1
                

                NewFreeSect%=NewFreeSect% + 1 ' ' Pointer to current sector in V9T9 Output Disk
                GlobalOutOffset%=GlobalOutOffset%+1
                CurSec% = CurSec% + 1   ' Pointer to sectors in "~TMPFIL.TMP" Source File. First sector is FDR
                IF CurSec% > SectorLength# THEN GOTO EOThisFilePr       
                GET #1, CurSec%         
                FITAU%=FITAU%-1
                
                IF FITAU%=0 THEN GOTO NextClusterPr
                GOTO ConsSecObtaind
        
                
                '<------------>
                '<------------> END OF THE SAME CHAIN BLOCK
                '<------------>
                
'**************************************
' CURRENT FILENAME : END OF CHAIN BLOCK
'**************************************
                
AbortThisFile:  GOSUB CloseOutput   'Close Output file
                GOSUB NameDisk   ' Get next output DiskName
                GOSUB CreateDisk    ' Create and open next output Filename
                GOTO ThisFileAgain  ' Process current file again

SkipThisFilT: PRINT "No file can be larger than 4096 sectors on a TI floppy."
                PRINT "Sectors used by FDR (File Descriptor Record) don't count."
                PRINT "Current file (";CHR$(34); FOut$;CHR$(34);") is"; SectorLength#-1; "sectors long and will be skipped!"
                GOTO SkipThisFil2


SkipThisFile:   L#=SectorLength#
                
                PRINT "File "; FOut$; " is too long ("; L#; "sectors) and doesn't fit into the chosen"
                PRINT "empty disk ("; DiskSize%; "sectors). It will be skipped!"
SkipThisFil2:   CALL ERRSOUND
                INPUT CCC$
                Skipped% = Skipped% + 1
                C$ = "S": GOTO TxferEnd    ' Process Nextfile
EOThisFilePr:
                GOSUB UpdateChainPointers
                IF Flag$="F" THEN GOTO GoLeaveXfer
                GlobalSectors# = GlobalSectors# + SectorLength# + 1                     
                
NotThisOne:     C$ = "": GOTO TxferEnd
GoLeaveXfer:    C$ = "UEABM"' Error condition: UNKNOWN ERROR IN ALLOCATION BIT MAP IN SECTOR ZERO
TxferEnd:       CLOSE #1                ' Close Input File
                RETURN



'=====================================
' "Unexpectedly,  Free Sector Not Found In Allocation Bit Map In Sector Zero. "
'=====================================
UnexpNoSect:                    
                PRINT "Unexpectedly, a free sector has not been found for FDR. "
                PRINT "Current file: ";left$(Sel.Tiname,10);", on disk: "; DestinPath$; ". Process will be aborted."; : INPUT "", C$
                RETURN          
'=====================================
' "Error: Free Sector Not Found In Allocation Bit Map In Sector Zero. "
'=====================================
NoFreeSecFnd:                   
                PRINT "ERROR: FREE SECTOR NOT FOUND IN ALLOCATION BIT MAP IN SECTOR ZERO. "
                PRINT "CURRENT FILE ";left$(Sel.Tiname,10);" ON THIS DISK ("; DestinPath$; ") WILL BE ABORTED"; : INPUT "", C$
                Call WriteChainPointers(FIDChain%,FirstSectIDC%,DiskSize%,GlobalOutOffset%,SectAU%,OutFDRSectr$,FOut$,Flag$)     ' Update Data Chain Pointers
                LSET DataSec$ = OutFDRSectr$
                PUT #2, NewFDR% + 1              ' Write FDR
                RETURN          

'=====================================
' "Error: Free Sector Not Found In Allocation Bit Map In Sector Zero. "
'=====================================
DCPBFull:                       
                PRINT "ERROR: DATA CHAIN POINTER BLOCK TABLE FULL! "
                PRINT "CURRENT FILE ";left$(Sel.Tiname,10);" ON THIS DISK ("; DestinPath$; ") WILL BE ABORTED"; : INPUT "", C$
                LSET DataSec$ = OutFDRSectr$
                PUT #2, NewFDR% + 1              ' Write FDR
                RETURN          
                                
'=======================
' UDPADTE CHAIN POINTERS
'=======================

UpdateChainPointers:

                Call WriteChainPointers(FIDChain%,FirstSectIDC%,DiskSize%,GlobalOutOffset%,SectAU%,OutFDRSectr$,FOut$,Flag$)     ' Update Data Chain Pointers

                'ff%=FREEFILE
                'OPEN "H:\OUT.DAT"  FOR BINARY ACCESS WRITE AS #ff%
                'PUT #ff%, 1 , OutFDRSectr$
                'CLOSE #ff%       
        
                IF Flag$="F" THEN GOSUB DCPBFull :  GOTO UpdateChPZ:' "F"= "Data Chain Pointer Block Table Full"
WriteFDR:
                LSET DataSec$ = OutFDRSectr$
                PUT #2, NewFDR% + 1              ' Write FDR

                LSET DataSec$ = OutSectrZero$
                PUT #2, 1
                LSET DataSec$ = OutSectrOne$
                PUT #2, 2
UpdateChPZ:     RETURN

'=================
'CLOSE OUTPUT FILE
'=================
CloseOutput: 
                LSET DataSec$ = OutSectrZero$
                PUT #2, 1
                LSET DataSec$ = OutSectrOne$
                PUT #2, 2
                
                'IF V9T9$ = "" THEN GOTO CloseOutput2 ' Default is now V9T9 format
                
                'T$ = MID$(OutErrTable$, 1, 256)
                'LSET DataSec$ = T$
                'PUT #2, DiskSize(TmpSize) + 1
                'T$ = MID$(OutErrTable$, 1 + 256, 256)
                'LSET DataSec$ = T$
                'PUT #2, DiskSize(TmpSize) + 2
                'T$ = MID$(OutErrTable$, 1 + 256 + 256, 256)
                'LSET DataSec$ = T$
                'PUT #2, DiskSize(TmpSize) + 3
CloseOutput2:        
                CALL AlphaDir(DxPath$)        ' Reorder alphabetically the Disk Image File just created
                CLOSE #2

                RETURN

                
'============================
' CREATE OUTPUT DISKNAME
'============================
NameDisk:       IF FirstDisk$ = "" THEN FirstDisk$ = "X": CALL TellPathFileExt(DestinPath$, DDPath$, DDNameExt$, DDJustName$, DDExt$) : Incr%=0: GOTO NameDisk3
                DestinPath$=NewFilename$ (DDPath$, DDJustName$, DDExt$, Incr%)
                IF DisksRound% = 0 THEN FirstDestinPath$ = DestinPath$
NameDisk3:
                RETURN
                
'=======================================
' CREATE VIRTUAL DISK (EMPTY IMAGE FILE)
'=======================================
CreateDisk:
                DriveParms(0)= DriveParms(Sauce) 
                GOSUB LoadParams ' Load all the vital Parameters from DriveParms(0)
                                
                PRINT "New Disk name: "; DestinPath$
                DxPath$ = DestinPath$
            
                CALL ShortLongName(DxPath$,CR$,3) ' 3 = Create a LongFilename if no ShortFilename exists. Return short filename.
               
                IF CR$ <> "" THEN GOTO CreateGoOn3
                ON ERROR GOTO CreateNoExists
                OPEN DxPath$ FOR INPUT ACCESS READ AS #2   ' Avoid creation of file is file doesn't exist
                CLOSE #2: ON ERROR GOTO 0

CreateExists: ' 
CreateExists2: 
                CLS
                CALL box(1, 2, 77, 12)
                LOCATE 2, 3: PRINT "The following disk image file:";
                LOCATE 4, 3: PRINT DestinPath$;
                LOCATE 5, 3: PRINT "already exists. ";
                LOCATE 7, 3: PRINT "You may:"
                LOCATE 8, 3: PRINT "- Overwrite [O]   - (it will Overwrite this file and all the next ones too)";
                LOCATE 9, 3: PRINT "- Skip      [S]   - (it will Skip this file only)"
                LOCATE 10, 3: PRINT "- Append    [A]   - (it will Append to this file only)"
                LOCATE 12, 15: PRINT "Your choice: O/S/A ? ";
                PRINT MK$
                IF MK$ = "O" THEN CLS : GOTO CreateGoOn2

                DO: MK$ = INKEY$: LOOP UNTIL MK$ <> "": MK$ = UCASE$(MK$)
                    
                IF MK$ = CHR$(27) THEN GOTO Leaveit
                IF MK$ = CHR$(0) + CHR$(59) THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "18.04.03"): GOTO CreateExists2
                IF MK$ <> "A" THEN GOTO NotAppend
                CLS : GOSUB CreateOpen: GOSUB SubtrUsdSectors
                IF AppendF$ = "Y" THEN RETURN
                CLOSE #2: MK$ = "S"' Else skip this file

NotAppend:      IF MK$ = "S" THEN CLS : GOSUB NameDisk: DisksRound% = DisksRound% - 1: GOTO CreateDisk ' Try again withj new filename
                BEEP
                GOTO CreateExists2

                
CreateNoExists: RESUME CreateGoOn
CreateGoOn:     ON ERROR GOTO 0
                
CreateGoOn2:    OPEN DxPath$ FOR BINARY ACCESS WRITE AS #2
                CLOSE #2
                KILL DxPath$
                DxPath$ = DestinPath$
                CALL ShortLongName(DxPath$,CR$,3) ' 3 = Create a LongFilename if no ShortFilename exists. Return short filename.
CreateGoOn3:    DisksRound% = DisksRound% + 1
                OPEN DxPath$ FOR BINARY ACCESS WRITE AS #2
                Z = 0: Tog% = 1: BytePos& = 1

                ' Add termination to TI99/4A filename '01', '02' and son on
                
                Incr$ = RTRIM$(LTRIM$(STR$(Incr%)))
                IF LEN(Incr$) < 2 THEN Incr$ = "0" + Incr$
                NewName$ = DskName$ + Incr$
                IF LEN(NewName$) < 10 THEN NewName$ = NewName$ + SPACE$(10 - LEN(NewName$))
                NewName$ = LEFT$(NewName$,10)
                
                SectorZero$ = NewName$ + LEFT$(DriveParms(0),3) + "DSK " + RIGHT$(DriveParms(0),3)
                IF SectAU% > 1 THEN T$ = CHR$(1) ELSE T$ = CHR$(3)
                'SectorZero$ = SectorZero$ + STRING$(36, CHR$(0)) + T$ + STRING$(199, CHR$(0))
                SectorZero$ = SectorZero$ + STRING$(36, CHR$(0)) + T$ + STRING$(UpperABM% - 1, CHR$(0))
                SectorZero$ = SectorZero$ + STRING$(256 - LEN(SectorZero$), CHR$(&HFF))
                
                PUT #2, BytePos&, SectorZero$: BytePos& = BytePos& + 256
                FillZero$ = STRING$(256, CHR$(0))
                PUT #2, BytePos&, FillZero$: BytePos& = BytePos& + 256
                
                FOR Record = 3 TO DiskSize% ' Sector 0 and 1 are already out, add remaining sectors
                PUT #2, BytePos&, DummyRec$: BytePos& = BytePos& + 256
                NEXT Record
                
                
                'OutErrTable$ = FillZero$
                'MID$(OutErrTable$, 1) = "Bad Sectors:       0"
                'IF V9T9$ = "" THEN GOTO CreateGoOn4 ' Default is now V9T9 format
                'PUT #2, BytePos&, OutErrTable$: BytePos& = BytePos& + 256
                'PUT #2, BytePos&, FillZero$: BytePos& = BytePos& + 256
                'PUT #2, BytePos&, FillZero$: BytePos& = BytePos& + 256
CreateGoOn4:         
                'OutErrTable$ = OutErrTable$ + FillZero$ + FillZero$
                
                CLOSE #2
                GOSUB CreateOpen   ' Open Output file and get fundamental sectors (0 and 1)
                'StillFree% = DiskSize(TmpSize) - 2
                StillFree% = DiskSize% - ((SectAU% AND 1) + SectAU%)

                RETURN
                
' Open Output file and get fundamental sectors
CreateOpen:
                OPEN DxPath$ FOR RANDOM ACCESS READ WRITE AS #2 LEN = 256
                FIELD #2, 256 AS DataSec$
                GET #2, 1
                OutSectrZero$ = DataSec$
                GET #2, 2
                OutSectrOne$ = DataSec$
                
                
                RETURN
                
'SUBTRACT USED SECTORS FROM OPENED FILE      
SubtrUsdSectors:
                DriveParms(0)=MID$(OutSectrZero$, 11, 3) + MID$(OutSectrZero$, 18, 3)
                GOSUB LoadParams ' Load all the vital Parameters from DriveParms(0)

                
                'DSideDensity$ = MID$("SD", DSides%, 1) + "S" + MID$("SDHE", DDens%, 1) + "D"  
                'TotSect&=SktTrk*TrkSide*NSides 
                DriveMatch$="N"
                IF DriveParms(Sauce)= DriveParms(0) THEN DriveMatch$="Y": GOTO DrivePMatch
                FOR TK=1 TO 16
                IF DriveParms(TK)= DriveParms(0) THEN GOTO DriveNoMatch
                NEXT TK 
                
                'CALL ERRSOUND: PRINT "Unknown disk size in SubtrUsdSectors: routine": INPUT C$: GOTO Leaveit
DriveNoMatch:           
                
DrivePMatch:  
                'TmpSize = TmpSize + ((ASC(MID$(OutSectrZero$, 18, 1)) / 40) - 1) * 6
                TmpSize = TK

                FOR J = 0 TO UpperABM%-1
                T$ = MID$(OutSectrZero$, 57 + J, 1)
                IF ASC(T$) = 0 THEN GOTO CrNextByte
                IF ASC(T$) < 255 THEN GOTO SubtrUsdSect2
                StillFree% = StillFree% - (8 * SectAU%)
                
                GOTO CrNextByte

SubtrUsdSect2:
                FOR W = 0 TO 7
                IF ASC(T$) AND 2 ^ W THEN StillFree% = StillFree% - SectAU%
                NEXT W
CrNextByte:     NEXT J
                PRINT TAB(2); "Existing Disk Name = "; DxPath$
                
                
                        
                PRINT TAB(20);"Ŀ";
                PRINT TAB(20);"                Disk to     Disk        ";
                PRINT TAB(20);"                append to/  originally  ";
                PRINT TAB(20);"                /overwrite  selected    ";
                PRINT TAB(20);"Ĵ";
                PRINT TAB(20);"                                        ";
                PRINT TAB(20);" Sectors                                "; 
                PRINT TAB(20);" Track/side                             "; 
                PRINT TAB(20);" Sectors/Track                          "; 
                PRINT TAB(20);" Sides                                  "; 
                PRINT TAB(20);" Density                                "; 
                PRINT TAB(20);" Sectors/AU                             "; 
                PRINT TAB(20);" Free sectors                           "; 
                PRINT TAB(20);" Used sectors                           "; 
                PRINT TAB(20);"                                        "; 
                PRINT TAB(20);"                                        "; 
                PRINT TAB(20);"";
              
                GOSUB LoadSauceParams ' Load all the vital Parameters from DriveParms(Sauce)
                
                LOCATE  8,40:  PRINT DiskSize%; : LOCATE  8,53 :PRINT SDiskSize%;
                LOCATE  9,40:  PRINT TrackSide%;: LOCATE  9,53 :PRINT STrackSide%;
                LOCATE 10,40:  PRINT SecTrack%; : LOCATE  10,53 :PRINT SSecTrack%;
                LOCATE 11,40:  PRINT NumSides%; : LOCATE  11,53 :PRINT SNumSides%; 
                LOCATE 12,40:  PRINT DiskDens%; : LOCATE  12,53 :PRINT SDiskDens%;
                LOCATE 13,40:  PRINT SectAU%;   : LOCATE  13,53 :PRINT SSectAU%; 
                LOCATE 14,40:  PRINT StillFree%;: LOCATE  14,53 :PRINT SStillFree%;  
                LOCATE 15,40:  PRINT DiskSize% - StillFree%;: LOCATE  15,53 :PRINT SDiskSize% - SStillFree%;
                IF DriveMatch$="N" THEN LOCATE 3,22: PRINT "Disks do not"; : LOCATE 4,22: PRINT "match!"; 
                
                LOCATE 19,1:
                
                IF DriveMatch$="N" THEN PRINT "The existing disk size doesn't match the disk size you've previously selected."
                PRINT     
                PRINT "Do you want to use the existing disk ";
                IF DriveMatch$="N" THEN PRINT "anyway (Y/N)?";  ELSE PRINT "(Y/N)?";
                DO: K$ = INKEY$: LOOP UNTIL K$ <> "": K$ = UCASE$(K$)
                IF K$ = CHR$(27) THEN K$ = "N"
                PRINT     
                AppendF$ = K$
                RETURN
                
' Load all the vital Parameters from DriveParms(0)
LoadParams: 
                DiskSize% = CalcWord(DriveParms(0),1)
                SectAU% = -1 * (INT((-DiskSize% / 1600)))  
                UpperABM%=DiskSize%/(8*SectAU%) ' Highest AU in Free/Used Bit Map Table in Sector Zero
                LowLimit%=INT(UpperABM%/12) 	' LowLimit% = Lowest sector where to begin to copy Data Sectors 
                'LowLimit%=INT(DiskSize%/12) 	' LowLimit% = Lowest sector where to begin to copy Data Sectors 
                                                ' in the Free/USed Bit Map in Sector Zero
                StillFree% = DiskSize%
                SecTrack%=ASC(MID$(DriveParms(0), 3, 1))
                TrackSide% = ASC(MID$(DriveParms(0), 4, 1)): IF TrackSide% = 0 THEN TrackSide% = 40
                
                NumSides% = ASC(MID$(DriveParms(0), 5, 1)): IF NumSides% = 0 THEN NumSides% = 1
                DiskDens% = ASC(MID$(DriveParms(0), 6, 1)): IF DiskDens% = 0 THEN DiskDens% = 1
                RETURN   

' Load all the vital Parameters from DriveParms(Sauce)
LoadSauceParams: 
                SDiskSize% = CalcWord(DriveParms(Sauce),1)
                SSectAU% = -1 * (INT((-SDiskSize% / 1600)))  
                SUpperABM%=SDiskSize%/(8*SSectAU%)  
                SLowLimit%=INT(SDiskSize%/12)
                SStillFree% = SDiskSize% - ((SSectAU% AND 1) + SSectAU%)
                SSecTrack%=ASC(MID$(DriveParms(Sauce), 3, 1))
                STrackSide% = ASC(MID$(DriveParms(Sauce), 4, 1)): IF STrackSide% = 0 THEN STrackSide% = 40
                
                SNumSides% = ASC(MID$(DriveParms(Sauce), 5, 1)): IF SNumSides% = 0 THEN SNumSides% = 1
                SDiskDens% = ASC(MID$(DriveParms(Sauce), 6, 1)): IF SDiskDens% = 0 THEN SDiskDens% = 1
                RETURN   
          
          
              
                
                                
                
SectorLength: ' Calculate file length, in sectors
                SectorLength# = CalcWord(FilName$(CurrentFilename%), 15) + 1
                RETURN
DispFilestoCopy: ' Display total files to be copied
                LOCATE 6, 58, 1
                PRINT TotFiles2Copy%; " ";
                LOCATE 6, 73, 1
                PRINT TotSizeFiles2Copy#; " ";
                RETURN
                
' Error trap of SUB FileExists()                
FileErrTrap:    FilErrFlg=1 
                RESUME NEXT
                
SUB GetAFreeSect(NewFreeSect%,DiskSize%,SectAU%,FITAU%,LowLimit%,UpperABM%,OutSectrZero$,Cmd$,Flag$)
                ' Flag$= "X" means "Error: Free Sector Not Found In Allocation Bit Map In Sector Zero. "
                ' Flag$= "U" means "Non consecutive sectors! Update chain pointers, a new Chain Block will start with this sector
                ' Flag$= "" means "OK, this new sector is consecutive, non need to Update Chain pointers
                OldSec%=NewFreeSect%
                ' Never call if there are still free sectors from the same AU
                
                SELECT CASE Cmd$
                
                CASE "B" ' Check All the Free/Used Sector Bit Map Area, starting from the beginning
                GOSUB GetAFreeSectLow : IF T%<>-1 THEN GOTO GotNewFreeSec
                GOSUB GetAFreeSectHigh : IF T%<>-1 THEN GOTO GotNewFreeSec
                        
                CASE "H" ' Check All the Free/Used Sector Bit Map Area, starting from the High Area. 
                         ' If it fails, search the Low area too.
                GOSUB GetAFreeSectHigh : IF T%<>-1 THEN GOTO GotNewFreeSec
                GOSUB GetAFreeSectLow : IF T%<>-1 THEN GOTO GotNewFreeSec
                END SELECT
                
                BEEP
                Flag$="X" ' "Error: Free Sector Not Found In Allocation Bit Map In Sector Zero. "
                GOTO NewFreeSectExit
                
                
' A new sector has been obtained                
GotNewFreeSec:   '*------- Update Sector Zero
                FITAU%=SectAU%
                CV% = CV% + 2 ^ ex%
                MID$(OutSectrZero$, 57 + T%) = CHR$(CV%) ' Mark that sector as used on Sector Zero
                NewFreeSect% = (T% * 8 + ex%)* SectAU%  ' Get the free sector number
                
                IF OldSec%=NewFreeSect% THEN Flag$="" ELSE Flag$="U" ' Flag$="" means new sector is consecutive,  Flag$="U" 
                ' Flag$="U" means new sector is NOT consecutive; so, DATA CHAIN POINTER in FDR must be updated  
                GOTO NewFreeSectExit
                
                ' Search High portion of Free/Used Sector Bit Map Area
GetAFreeSectHigh:
                FOR T% = LowLimit% + 1 TO UpperABM% - 1 
                'FOR T% = LowLimit% + 1 TO UpperABM% - 1 ' LowLimit% = Lowest sector where to begin to copy Data Sectors 
                                                                ' in the Free/USed Bit Map in Sector Zero
                CV% = ASC(MID$(OutSectrZero$, 57 + T%, 1))
                IF CV% = 255 THEN GOTO GetAFreeSectHighN
                FOR ex% = 0 TO 7
                IF (CV% AND 2 ^ ex%) = 0 THEN GOTO GetAFreeSectHighZ
                NEXT ex%
                
GetAFreeSectHighN:  NEXT T%
                T=-1
GetAFreeSectHighZ: RETURN 

' Finally , check the FDR area
GetAFreeSectLow:
                FOR T% = 0 TO LowLimit%
                CV% = ASC(MID$(OutSectrZero$, 57 + T%, 1))
                IF CV% = 255 THEN GOTO GetAFreeSect4
                FOR ex% = 0 TO 7
                IF (CV% AND 2 ^ ex%) = 0 THEN GOTO GetNewFreeSecLowZ
                NEXT ex%
                
GetAFreeSect4:  NEXT T%
                T=-1
GetNewFreeSecLowZ: 

                RETURN 
                
NewFreeSectExit:
                END SUB
                
SUB WriteChainPointers(FIDc%,FFSectIDC%,DiskSize%,GlobOff%,SAU%,OutFDRSectr$,FOut$,Flag$)
                'GlobOff% must become 1 only AFTER one data sector has been really written to the output disk.
                Flag$=""
                IF FIDc% < 253 THEN GOTO WriteChainP2
                PRINT 
                PRINT "Data Chain Pointer Block Table Full for file: "; FOut$; ". Disk is too fractured!"
                PRINT "This file will be closed and remain uncomplete.";
                INPUT "", CCCC$
                Flag$="F" ' "F"= "Data Chain Pointer Block Table Full"
                'LSET DataSec$ = OutFDRSectr$
                'PUT #2, NewFDR% + 1               ' Write FDR
                'FIDc% = 0  ' This to make the caller understand that table is full
                '                ' Pointer to First In Data Chain Pointer Block in Output File Descriptor Record                
                GOTO NoChainPointr

WriteChainP2:   IF GlobOff% = 0 THEN GOTO NoChainPointr ' Zero Length File
                IF DiskSize%>4095 THEN FUITB%=INT(FFSectIDC% / SAU%) ELSE FUITB%=FFSectIDC% ' First Used In This Block
                ' Only when DiskSize is above or equal to 4096 does the FDR has to be divided by AU. The FDR uses 3 bytes, 
                ' by which you can count up to 4095. This is why with a 2880 sector disk you don't have to divide
                ' while with 5760 disks (and above) you have to divide. For the same reason, no file can be larger than 4096 sectors.
                
                GlOff% = GlobOff% - 1 
                
              ' **************************************************************************************************
              '                                  DATA CHAIN POINTER BLOCK STRUCTURE 
              ' **************************************************************************************************
                '  Each entry, formed by 3 consecutive bytes, holds 2 values:
                '  1) a Pointer to the First Sector containing Data in this Data Block (FFreeSectIDC% in this source code)
                '  2) an offset that tells you how many sectors there are in this Data Block besides the first sector 
                '     (GlobalOutOffset% in this source code)
                ' Each value is costrained into 12 bits, i.e. 3 nibbles. 12 bits can address up to 4095. As a consequence, 
                ' no value higher than  4095 can be stored in this Data Chain Pointer Block structure. 
                ' However, this poses a problem for disks holding 5760 or more sectors. 
                ' Myarc solved it by dividing by 4 the value there contained (in their 5760 sector disk (DSHD)).
                ' 4 is also the SectAU value (Sectors per Allocation Unit) for a 5760 sector disk. This is no coincidence, because 
                ' a Data Block must start on an even boundary, multiple of SectAU. So, when this pointer is needed, it suffices 
                ' to multiply it by SectAU back again and there you the full pointer is ready! 
                ' I think this solved nicely the problem.
                '
                ' The second value in the Data Chain Pointer Block structure is the offset (GlobalOutOffset% in this code). It is never 
                ' divided by SectAU and reflects the number of the last sector belonging to this Data Chain Pointer Block (the 
                ' first sector being sector 0).
                ' 
                ' FUITB%    = ss3*256 + ss2*16 + ss1 
                ' GlOff%    = of3*256 + of2*16 + of1
                ' +---------+---------+---------+  
                ' | Byte 1  | Byte 2  | Byte 3  |
                ' +----+----+----+----+----+----+   
                ' |Nib1|Nib2|Nib3|Nib4|Nib5|Nib6|
                ' +----+----+----+----+----+----+   
                ' | ss2 ss1 | of1 ss3 | of3 of2 |
                ' +---------+---------+---------+   
                '
                ' Example1: 
                '         A file with only one sector, starting at sector >3D5, has the following
                '         Data Chain Pointer Block: D5 03 00 
                '        1st sector = >3D5 - Last file sector in this block = >000 This block holds 1 sector only.
                '         The offset is zero, because Sector Zero (the first sector) is also the last sector of the file.
                ' Example2:       
              '          File: H:\TI99-4A\ASSMBL-006.img  8/19/2008, 10:11:50PM
              '          00000600h: 52 45 4C 4F 41 44 45 52 2D 42 00 00 80 03 00 2A ; RELOADER-B....*
              '          
              '          00000610h: DC 50 2A 00 00 00 00 00 00 00 00 00 AD 70 02 FF ; P*.........p.
              '                                                         ----1--- ++
              '          00000620h: 81 02 0E 92 02 00 00 00 00 00 00 00 00 00 00 00 ; ..............
              '                     +2+++ ***3****
              '          00000630h: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ; ................
                ' 
                '          The DIS/VAR 80 file "RELOADER-B" is 43 sector long (not counting the sector needed 
                '          for the FDR). The disk holds 2880 sectors and has SectAU = 2
                '          
              '           Data Chain Pointer Blocks: 
              '           AD 70 02 - 1st sector = >0AD - Last file sector in this block = >027 This block holds 40 sectors
              '           FF 81 02 - 2nd sector = >1FF - Last file sector in this block = >028 This block holds  1 sector  
              '           0E 92 02 - 3rd sector = >20E - Last file sector in this block = >029 This block holds  1 sector
WriteChainP3: 
                ss3% = INT(FUITB% / 256)
                ss1% = FUITB% MOD 16
                ss2% = FUITB% - (ss3% * 256) - ss1%
                ss2% = INT(ss2% / 16)
                
                of3% = INT(GlOff% / 256) ' GLOBAL Offset in Output File Chain Pointer Block
                of1% = GlOff% MOD 16    
                of2% = GlOff% - (of3% * 256) - of1%
                of2% = INT(of2% / 16)

                'T$ = CHR$((ss2% * 16 + ss1%) AND 255) + CHR$((of1% * 16 + ss3%) AND 255)  + CHR$((of3% * 16 + of2%) AND 255) 
                T$ = CHR$(ss2% * 16 + ss1%) + CHR$(of1% * 16 + ss3%) + CHR$(of3% * 16 + of2%) 
                MID$(OutFDRSectr$, FIDc%) = T$ 'FIDChain% = Pointer to First In Data Chain Pointer Block in Output File Descriptor Record
                FIDc% = FIDc% + 3   'FIDChain% = Pointer to First In Data Chain Pointer Block in Output File Descriptor Record

NoChainPointr:
                
                END SUB                                 
                
FUNCTION NewFilename$ (Path$, JustName$, Ext$, Term%)
' Syntax
                ' Form the string from the number, left padded with zeroes
                Term% = Term% + 1
                Ter$ = RTRIM$(LTRIM$(STR$(Term%)))
                IF LEN(Ter$) < 3 THEN Ter$ = STRING$(3 - LEN(Ter$), "0") + Ter$
                Ter$ = "-" +Ter$        
                SELECT CASE MyVal(0)
              
                CASE IS > 999' Windows
                    NewFilename$ = Path$ + JustName$ + Ter$ + Ext$
               CASE ELSE  ' DOS
               
                   SELECT CASE LEN(JustName$)
                   CASE 7 TO 8
                   NewFilename$ = Path$ + LEFT$(JustName$, 6) + RIGHT$(Ter$,2) + Ext$
                   CASE  6
                   
                       NewFilename$ = Path$ + JustName$ + RIGHT$(Ter$,2) + Ext$
                    CASE 5
                       NewFilename$ = Path$ + JustName$ + RIGHT$(Ter$,3) + Ext$
                   CASE IS < 5
                       NewFilename$ = Path$ + JustName$ + RIGHT$(Ter$,4) + Ext$
                   CASE ELSE
                       NewFilename$ = Path$ + JustName$ + RIGHT$(Ter$,4) + Ext$
                   
                   END SELECT
                   
              
              END SELECT
              
END FUNCTION

SUB TellPathFileExt(Full$, Path$, NameExt$, JustName$, Ext$)
' Example:
' CALL  TellPathFileExt("C:\MyDir\SubDir\ThisProg.exe", Path$, NameExt$,JustName$, Ext$)
' will return:
'    Path$="C:\MyDir\SubDir\"
'    NameExt$="ThisProg.exe"
'    JustName$="ThisProg"
'    Ext$=".exe"

                Path$="": NameExt$="":JustName$="":Ext$=""
                ' Separate Path from Filename (Naim$)
                FOR T = LEN(Full$) TO 1 STEP -1
                IF MID$(Full$, T, 1) = "\" THEN Path$ = LEFT$(Full$,  T): NameExt$ = RIGHT$(Full$, LEN(Full$) -T): GOTO PathFileExt4
                NEXT T
                NameExt$ = Full$
PathFileExt4:           
        
      ' Separate Filename (JustName$) from Extension (Ext$)
                FOR T = LEN(NameExt$) TO 1 STEP -1
                IF MID$(NameExt$, T, 1) = "." THEN JustName$ = LEFT$(NameExt$, T-1): Ext$ = RIGHT$(NameExt$,  LEN(NameExt$) - T +1 ): GOTO PathFileExt8
                NEXT T
                JustName$ = NameExt$
PathFileExt8: 
                END SUB

SUB AlphaDir (DestDisk$) ' Alphabetically reorder an Image Disk (Sector 1)
' Example:
' Call AlphaDir("C:\TEM\TI-PC.IMG")

                OPEN DestDisk$ FOR RANDOM ACCESS READ WRITE AS #9 LEN = 256
                FIELD #9, 256 AS DSec$
                GET #9, 2               ' Get Sector 1: Filename Table, alphabetically ordered
                SectrOne$ = DSec$

                TFNames% = 0           ' We have to work out how many filenames there are
NextFilNam:     sn% = CalcWord(SectrOne$, (TFNames% + 1) * 2 - 1)
                IF sn% <> 0 THEN TFNames% = TFNames% + 1: GOTO NextFilNam

                IF TFNames% = 0 THEN GOTO AlphaDirZ

                REDIM FilName$(TFNames%)   ' DIM exactly our arrays
                REDIM StSect$(TFNames%)   ' DIM exactly our arrays
                FOR T = 1 TO TFNames%
                StSect$(T) = MID$(SectrOne$, (T * 2 - 1), 2)
                StartSect% = CalcWord(SectrOne$, (T * 2 - 1))
                GET #9, StartSect% + 1
                FilName$(T) = MID$(DSec$, 1, 10)
                NEXT T
                
                
                
                ' AVOID DUP NAMES
                ' Dup names will be renamed with a leading Tilde character ("~"), for instance: "~filename"
                L! = 0
                FOR K = 1 TO TFNames% - 1
                FOR T = K + 1 TO TFNames%
                IF FilName$(K) <> FilName$(T) THEN GOTO NoDup
                A1$ = RTRIM$(FilName$(T))
                IF LEN(A1$) < 10 THEN A1$ = "~" + A1$ + SPACE$(10 - LEN(A1$) - 1) ELSE A1$ = "~" + LEFT$(A1$, 9)
                PRINT "Incoming file "; FilName$(T); " will be renamed as "; A1$; " to avoid a duplicate name"
                L! = L! + 1
                IF INT(L! / 20) = L! / 20 THEN CALL PressToContinue
                
                FilName$(T) = A1$
                StartSect% = CalcWord(StSect$(T), 1)
                GET #9, StartSect% + 1
                A2$ = DSec$
                MID$(A2$, 1, 10) = FilName$(T)
                LSET DSec$ = A2$
                PUT #9, StartSect% + 1
                
NoDup:          NEXT T
                NEXT K
                IF L! = 0 THEN GOTO NoDupEnd
                PRINT L!; "filenames have been renamed to avoid duplicate names."
                CALL PressToContinue
                
                
NoDupEnd:            
                
                ' REORDER ALPHABETICALLY
                ' Find Lowest element. Start from element 1; compare all others with element 1. If lowest found, swap with element 1
                ' Next round, Find lowest starting from element 2; compare all others with element 2. If lowest found, swap with element 2
                ' Next round, Find lowest starting from element 3; compare all others with element 3. If lowest found, swap with element 3
                ' Next round, ...
                
                IF TFNames% = 1 THEN GOTO InOrder3
                K = 1
LoopBack:       L = K: T = K + 1
LoopBack2:      IF FilName$(L) <= FilName$(T) THEN GOTO InOrder
                L = T   ' New lowest element found
InOrder:        T = T + 1
                IF T <= TFNames% THEN GOTO LoopBack2
                IF L = K THEN GOTO InOrder2
                'Swap lowest element with first element
                A1$ = FilName$(K): A2$ = StSect$(K)
                FilName$(K) = FilName$(L): StSect$(K) = StSect$(L)
                FilName$(L) = A1$: StSect$(L) = A2$
InOrder2:           
                K = K + 1: IF K < TFNames% THEN GOTO LoopBack
InOrder3:    
                FOR T = 1 TO TFNames%
                MID$(SectrOne$, (T * 2 - 1), 2) = StSect$(T)
                NEXT T
                ' CALL ShowHex(SectrOne$,K$)

                LSET DSec$ = SectrOne$
                PUT #9, 2                ' Write Sector 1: Filename Table, alphabetically ordered

                ERASE FilName$  ' Free memory
                ERASE StSect$
AlphaDirZ:      CLOSE #9
                
END SUB

SUB box (Y, X, W, H)

                ' Call Box(StartRow, StartColumn, Width, Height)
                ' Y=StartRow,X=StartColumn; W=Width,H=Height)
                LOCATE Y, X
                PRINT ""; : FOR T = 1 TO W - 2: PRINT ""; : NEXT T: PRINT "";
                
                FOR V = 1 TO H - 2
                LOCATE Y + V, X
                PRINT ""; TAB(X + W - 1); : PRINT "";
                NEXT V

                LOCATE Y + H - 1, X
                PRINT ""; : FOR T = 1 TO W - 2: PRINT ""; : NEXT T: PRINT "";


END SUB

FUNCTION CalcWord (A$, P%)
                IF P% < 1 THEN INPUT "Wrong Position in CalcWord Subroutine", C$: V% = 0: GOTO CalcWord1
                IF LEN(A$) < P% + 1 THEN INPUT "Wrong String in CalcWord Subroutine", C$: V% = 0: GOTO CalcWord1
                B1% = ASC(MID$(A$, P%, 1))
                B2% = ASC(MID$(A$, P% + 1, 1))
                V% = (B1% * 256) + B2%
CalcWord1:      CalcWord = (V%)
END FUNCTION

DEFSNG A-Z

DEFINT A-Z
SUB ERRSOUND
                SOUND 110, 4

END SUB

SUB Fischio
                IF MyVal(1) = 0 THEN EXIT SUB
                FOR i% = 3000 TO 4000 STEP 200
                SOUND i%, .1  'i% / 1000
                NEXT i%
                
END SUB

DEFSNG A-Z
' Make sure to Delete the temp file, if any
SUB KillFile (A$)
                nF% = FREEFILE       
                OPEN A$ FOR OUTPUT AS #nF%
                CLOSE #nF%
                KILL A$
END SUB

DEFINT A-Z
SUB PressToContinue
                PRINT " - Press any key to continue - "
                DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
END SUB

DEFSNG A-Z
SUB ShortLongName (A$,B$,FUNC As Integer)
' Get either a LongName or a Shortname, depending on the value assigned to the control variable FUNC
' FUNC = 1  -  Get ShortFilename (8.3 characters) out of a LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 2  -  Get LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 3  -  Get ShortFilename (8.3 characters) out of a LongFilename. Create one LongFilename if no ShortFilename exists.
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.
'      = 4  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the longest Filename available. If file is created, a second record containing "CR!" will be returned. 
'      = 5  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.
                B$=""
                SELECT CASE MyVal(0)
                CASE 0 TO 999  ' Plain DOS OS
                EXIT SUB
                CASE 1000 TO 1999  ' Windows 95, 98, XP
                GOTO ShortLongN1
                CASE 2000 TO 3000  ' Windows XP, Vista
                GOTO ShortLongN1
                CASE ELSE
                END SELECT
                EXIT SUB
                
ShortLongN1:    Select CASE FUNC
                CASE 1  ' Get short filename (8.3 characters) but don't create a new file.
                C$ = "INT7160.com"
                CASE 2  ' Get Longest Filename but don't create a new file.
                C$ = "INT716RL.com"
                CASE 3  ' Get ShortFilename and create a long one if none exists. Return the short one anyway
                C$ = "INT716C.com"
                CASE 4  ' Get Long Filename out of a short one. Create a long one if none exists.
                C$ = "INT716CO.com"  ' The new  filename returned to the caller will be of the longest type available.
                CASE 5  ' Get Long Filename out of a short one. Create a long one if none exists.
                C$ = "INT716CL.com"  ' The new  filename returned to the caller will be of the shortest type available.

                CASE Else
                Exit Sub
                END SELECT
                
                
                C$ = C$ + " " + A$ + " >--"'Redirect output to a file named "--"
                SHELL C$
                
                ff% = FREEFILE
                OPEN "--" FOR INPUT AS #ff%
                IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
                LINE INPUT #ff%, A$
                IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
                LINE INPUT #ff%, B$
ShortLongN2:    CLOSE #ff%
                KILL "--"
END Sub

DEFINT A-Z
SUB ShowHex (A$, K$)
' This is simply to help during debugging
' Syntax: CALL ShowHex(A$,K$) ' A$ usually contains an entire TI Sector (256 bytes)
                Col% = 3
                B$ = ""
                FOR T = 1 TO LEN(A$)
                C$ = HEX$(ASC(MID$(A$, T, 1))): IF LEN(C$) = 1 THEN C$ = "0" + C$
                B$ = B$ + C$ + " "
                NEXT T
                
                LOCATE 10, Col% + 2
                PRINT "Addr. 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F ";
                
                IF K$ = "" THEN T = LEN(B$) - (8 * 16 * 3 - 1) ELSE T = 1
'===============LOOP STARTS HERE
                
Repeat:
                T$ = MID$(B$, T, 16 * 3)
                LOCATE 10 + 1 + Row%, Col% + 2:
                H$ = HEX$(T / 3): IF LEN(H$) = 1 THEN H$ = "0" + H$
                PRINT USING "\  \"; H$;
                LOCATE 10 + 1 + Row%, Col% + 5
                PRINT " - "; T$;
                PRINT "  ";
                FOR J = 1 TO 16
                J$ = MID$(A$, (T - 1) / 3 + J, 1)
                IF ASC(J$) < 32 OR ASC(J$) > 126 THEN PRINT " ";  ELSE PRINT J$;
                
                NEXT J
                
                Row% = Row% + 1: IF Row% < 8 THEN GOTO NextRow ELSE Row% = 0
                DO
                K$ = INKEY$
                LOOP UNTIL K$ <> ""
                K$ = UCASE$(K$)
                IF K$ = CHR$(27) THEN GOTO GEXIT
                
                ' Arrow Down
                IF K$ <> CHR$(0) + CHR$(80) THEN GOTO ArrowUPkey
                T = T - (16 * 3 * 6): IF T < 1 THEN T = 1
                GOTO Repeat
                
ArrowUPkey:      ' Arrow UP
                IF K$ <> CHR$(0) + CHR$(72) AND K$ <> CHR$(0) + CHR$(73) THEN GOTO NextRow
                IF K$ <> CHR$(0) + CHR$(72) THEN GOTO PageUPKey
                IF T < 8 * 16 * 3 THEN K$ = CHR$(0) + CHR$(72): GOTO GEXIT
                T = T - (16 * 3 * 8): IF T < 1 THEN T = 1
                GOTO Repeat
PageUPKey:  
                ' Page UP
                IF T < 8 * 16 * 3 THEN K$ = CHR$(0) + CHR$(72): GOTO GEXIT
                T = T - (16 * 3 * 15): IF T < 1 THEN T = 1
                GOTO Repeat

NextRow:
                T = T + (16 * 3)
                IF T < LEN(B$) THEN GOTO Repeat
                K$ = "Y"
'===============LOOP ENDS HERE
GEXIT:
END SUB

DEFSNG A-Z
FUNCTION Shrink$ (In$)
                A$ = "": c1$ = " "
                FOR T = 1 TO LEN(In$): C$ = MID$(In$, T, 1): IF C$ = " " AND c1$ = " " THEN GOTO SKIP
                A$ = A$ + C$: c1$ = C$
SKIP:
                NEXT T
                A$ = LTRIM$(RTRIM$(A$))
                Shrink = A$
END FUNCTION

SUB ThisHelp (Banner$, DatFile$, IDXFile$, Argum$)
                GOTO GetHelp

' Will use Chapter 7 from help file "Manual.dat", indexed in "Manual.idx" file.
' Because of MS QBasic quirks, GetIDX routine has to be placed before the rest of the code.
'
' Get .IDX file values into an array, that is,
' Get Array Parameters from Index (IDX) file
GetIDX:
                
                OPEN IDXFile$ FOR RANDOM ACCESS READ AS #3 LEN = LEN(IDXRecord)
                GET #3, , IDXRecord
                TLines% = IDXRecord.StartRec' First record is special: total records that follow
                
                
                REDIM IDXSect$(TLines%)
                REDIM IdxStart(TLines%)
                REDIM IdxLength(TLines%)
                FOR T = 1 TO TLines%
                GET #3, , IDXRecord
                IDXSect$(T) = LTRIM$(IDXRecord.Section)
                IdxStart(T) = IDXRecord.StartRec
                IdxLength(T) = IDXRecord.RecLength
                IDXSect$(T) = LTRIM$(RTRIM$(IDXSect$(T)))
                NEXT T
                CLOSE #3
                
                RETURN
                

GetHelp:        CLS
                LOCATE 1, 26: PRINT Banner$
                InizRw% = 2
                TotScrRws% = 12
                CurrScrRw% = 1
                
                GOSUB RedrawBox
                GOSUB GetIDX
                FOR Arg% = 1 TO TLines%
                IF Argum$ = IDXSect$(Arg%) THEN GOTO ArgFnd
                NEXT Arg%
                Arg% = 1
                
ArgFnd:         CurntLine% = Arg%
                RcLen% = 77 + 2
                OPEN DatFile$ FOR RANDOM ACCESS READ AS #59 LEN = RcLen%
                FIELD #59, RcLen% - 2 AS DL$
                FIELD #59, 2 AS CRLF$
                
'===================================
' MAIN LOOP STARTS HERE
'===================================
NextLineName:
                COLOR 7, 0
                
                IF CurrScrRw% = 1 THEN FstLine% = CurntLine%   ' Get Number of first Line only
                GOSUB DisplayRw
                CurntLine% = CurntLine% + 1 ' Next Line
                LastScrRw% = CurrScrRw%      ' Save last Screen Row used
                CurrScrRw% = CurrScrRw% + 1  ' Next Screen Row
                IF CurrScrRw% < TotScrRws% + 1 AND CurntLine% <= TLines% THEN GOTO NextLineName
'===================================
' MAIN LOOP ENDS HERE
'===================================
'
                GOSUB BotLine              ' Clear Unused Bottom Lines
                LastLine% = CurntLine% - 1
                CurntLine% = FstLine%  ' Current Line is now first Line in screen
                
                CurrScrRw% = 1
                IF KeepCursBot% = 0 THEN GOTO LocCursor2
                ' Last key used was Arrow Down. Move Cursor and FileNumber pointer to last Line in Screen
                CurrScrRw% = TotScrRws%: KeepCursBot% = 0: CurntLine% = LastLine%
                GOTO LocCursor2
                
LocCursor:
                GOSUB HeRestColor

LocCursor2:
                LOCATE InizRw% + CurrScrRw%, 2, 1
                COLOR 0, 7: GOSUB DisplayRw: COLOR 7, 0 ' Display Current Row
                LOCATE InizRw% + CurrScrRw%, 2, 1
                OldScrRw% = CurrScrRw%
                OldLine% = CurntLine%
                IF GoToThisDir% <> 0 THEN CurntLine% = GoToThisDir%: GoToThisDir% = 0: GOTO Exekit
                'GOSUB ShowValues    ' My little Debugger
                
                
DoHeAgain:      GOSUB GetChar

                ' IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO DoHeAgain

                ' ESCape Key
                IF UH$ = CHR$(27) THEN GOTO HAbort
                
                ' ENTER Key
                IF UH$ <> CHR$(13) THEN GOTO IsArrDown
EnterKey:       CALL Fischio
                GOSUB ThisSect
                GOSUB RePaintHelp
                GOTO NMatch

IsArrDown:     ' Arrow Down Key
                IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO OthKey0
                IF CurrScrRw% < LastScrRw% THEN CurrScrRw% = CurrScrRw% + 1: CurntLine% = CurntLine% + 1: GOTO LocCursor
                IF CurntLine% = TLines% THEN GOTO LocCursor
                CurntLine% = FstLine% + 1
                KeepCursBot% = 1
                IF CurntLine% < 1 THEN CurntLine% = 1
                GOTO Exekit
OthKey0:         'Arrow up Key
                IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO OthKey1
                IF CurntLine% = 1 THEN GOTO NMatch
                IF CurrScrRw% > 1 THEN CurrScrRw% = CurrScrRw% - 1: CurntLine% = CurntLine% - 1: GOTO LocCursor
                CurntLine% = FstLine% - 1: IF CurntLine% < 1 THEN CurntLine% = 1
                GOTO Exekit
                
OthKey1:         ' Page Up Key
                IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO OthKey2
                CurntLine% = FstLine% - TotScrRws%
                IF CurntLine% < 1 THEN CurntLine% = 1
                GOTO Exekit

OthKey2:        ' Page Down Key
                IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO OthKey7
                IF LastLine% + 1 + TotScrRws% > TLines% THEN CurntLine% = TLines% - TotScrRws% + 1: IF CurntLine% < 1 THEN CurntLine% = 1: GOTO Exekit
                CurntLine% = FstLine% + TotScrRws%
                IF CurntLine% > TLines% THEN CurntLine% = FstLine%
                GOTO Exekit
                
OthKey7:         ' Home Key : simply move cursor to top
                IF UH$ <> CHR$(0) + CHR$(71) THEN GOTO OthKey8
                CurrScrRw% = 1: CurntLine% = FstLine%: GOTO LocCursor

OthKey8:         ' End Key : simply move cursor to bottom
                IF UH$ <> CHR$(0) + CHR$(79) THEN GOTO OthKey9
                CurrScrRw% = LastScrRw%: CurntLine% = LastLine%
                GOTO LocCursor
                
OthKey9:        ' F3 = Show Error List
                IF UH$ <> CHR$(0) + CHR$(61) THEN GOTO OthKey10
                GOSUB RePaintHelp
                GOTO NMatch

OthKey10:       ' F7 = Show Sector as Hex
                IF UH$ <> CHR$(0) + CHR$(65) THEN GOTO OthKey11
                GOSUB RePaintHelp
                GOTO NMatch
                
OthKey11:       'CTRL Page Down
                IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO OthKey13
                GOTO EnterKey

OthKey13:
                GOTO NMatch


Exekit:         CurrScrRw% = 1     ' Cursor on first screen row
                LOCATE InizRw% + CurrScrRw%, 2, 1
                GOTO NextLineName   ' Start next round

NMatch:         GOTO LocCursor
                
RePaintHelp:
                GOSUB RedrawBox
                SaveCurrLine% = CurntLine%
                SavCurrScrRw% = CurrScrRw%
                CurntLine% = FstLine%
                FOR CurrScrRw% = 1 TO TotScrRws%
                GOSUB DisplayRw  ' Display Current Row
                CurntLine% = CurntLine% + 1 ' Next Line
                LastScrRw% = CurrScrRw%      ' Save last Screen Row used
                IF CurntLine% > TLines% THEN CurrScrRw% = CurrScrRw% + 1: GOTO RePaintHelp2
                NEXT CurrScrRw%   ' Next Screen Row
                
RePaintHelp2:
                
                CurntLine% = SaveCurrLine%
                CurrScrRw% = SavCurrScrRw%
                RETURN

HeRestColor:    TempScreenRw% = CurrScrRw%
                TempLine% = CurntLine%
                CurrScrRw% = OldScrRw%
                CurntLine% = OldLine%
                COLOR 7, 0: GOSUB DisplayRw ' Display Current Row
                CurrScrRw% = TempScreenRw%
                CurntLine% = TempLine%
                RETURN

'==========================
' DISPLAY CURRENT ROW
'==========================
DisplayRw:
                LOCATE InizRw% + CurrScrRw%, 2, 1
                GET #59, IdxStart(CurntLine%)
                TL$ = DL$
                FOR T = 1 TO LEN(TL$): IF MID$(TL$, T, 1) <> " " AND MID$(TL$, T, 1) <> "*" THEN GOTO StrtFound
                NEXT T
StrtFound:      TL$ = RIGHT$(TL$, LEN(TL$) - T + 1)
                
                FOR T = LEN(TL$) TO 1 STEP -1: IF MID$(TL$, T, 1) <> " " AND MID$(TL$, T, 1) <> "*" THEN GOTO EndFnd
                NEXT T
EndFnd:         TL$ = LEFT$(TL$, T)
                PRINT IDXSect$(CurntLine%); TAB(12); TL$; SPACE$(79 - 12 - LEN(TL$));
                RETURN
                
'====================
' CLEAR BOTTOM LINES
'====================
BotLine:
                
                LOCATE InizRw% + CurrScrRw%, 2, 1

                IF CurrScrRw% >= TotScrRws% THEN GOTO HlpClear ' Blank all unused screen rows, if any

                FOR V = CurrScrRw% TO TotScrRws%
                LOCATE InizRw% + V, 2, 1
                PRINT "                                                                              "
                NEXT V
                
HlpClear:       LOCATE 23, 1: PRINT "Enter=Get Doc. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
                RETURN

                
' Create Box
RedrawBox:      CALL box(2, 1, 80, TotScrRws% + 2)
                RETURN
Pranyk:

                PRINT "                         - press any key to return -"
                GOSUB GetChar
                RETURN
                
GetChar:
                DO: UH$ = INKEY$: LOOP UNTIL UH$ <> ""
                RETURN


ThisSect:       TotSectRws% = 19
                SectInizRw% = 2
                SectCurrRw% = 1
                SectStart# = IdxStart(CurntLine%)
                SectCount# = IdxLength(CurntLine%)
                SectCurr# = 0
                Blank$ = SPACE$(78)
                LOCATE 23, 1: PRINT "Enter=Line Down. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
                CALL box(2, 1, 80, TotSectRws% + 2)
NewRound:
                FirstRec# = SectCurr#
SectNewLine:
                GET #59, SectStart# + SectCurr#
                LOCATE SectInizRw% + SectCurrRw%, 2, 1
                PRINT DL$;
                SectCurr# = SectCurr# + 1
                LastSectRw% = SectCurrRw%      ' Save last Screen Row used
                SectCurrRw% = SectCurrRw% + 1
                IF SectCurrRw% < TotSectRws% + 1 AND SectCurr# < SectCount# THEN GOTO SectNewLine
                
                FOR V = SectCurrRw% TO TotSectRws%
                LOCATE SectInizRw% + V, 2
                PRINT Blank$;
                NEXT V
                
GetAnother:     GOSUB GetChar
                'IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO GetAnother
                SectCurr# = FirstRec#
                SectCurrRw% = 1
                ' ESC Key
                IF UH$ = CHR$(27) THEN GOTO SectExit
                
                ' ENTER Key
                IF UH$ <> CHR$(13) THEN GOTO SectArrowDown
SectEnter:      IF SectCurr# < SectCount# - 6 THEN SectCurr# = SectCurr# + 1
                GOTO NewRound
                
SectArrowDown:  ' Arrow Down Key
                IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO SectKey0
                GOTO SectEnter
                
SectKey0:       'Arrow up Key
                IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO SectKey1
                IF SectCurr# > 0 THEN SectCurr# = SectCurr# - 1
                GOTO NewRound
SectKey1:
                ' Page Up Key
                IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO SectKey2
SectPageUp:     SectCurr# = SectCurr# - TotSectRws%
                IF SectCurr# < 0 THEN SectCurr# = 0
                GOTO NewRound
                
SectKey2:        ' Page Down Key
                IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO SectKey11
SectPageDown:   SectCurr# = SectCurr# + TotSectRws%
                IF SectCurr# > SectCount# - TotSectRws% THEN SectCurr# = SectCount# - TotSectRws%
                IF SectCurr# < 0 THEN SectCurr# = 0
                GOTO NewRound
                
SectKey11:      'CTRL Page Down
                IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO SectKey12
                GOTO SectPageDown
                
SectKey12:      'CTRL Page Up
                IF UH$ <> CHR$(0) + CHR$(132) THEN GOTO SectKey13
                GOTO SectPageUp
SectKey13:
                GOTO NewRound
SectExit:
                V = InizRw% + TotScrRws%
                LOCATE V, 1, 1
                IF V >= 22 THEN GOTO DontDoit ' Blank all unused screen rows, if any

                FOR V = V TO 23
                LOCATE V, 1, 1
                PRINT SPACE$(80)
                NEXT V
DontDoit:
                
                RETURN
HAbort:
                CLOSE #59
END SUB

FUNCTION FileExists(FulPath$)
' IF FileExists(KPath$)<>0 THEN GOTO FileDoesntExist

                FilErrFlg=0
                FF%=FREEFILE
                ON ERROR GOTO FileErrTrap
                OPEN FulPath$ FOR INPUT AS #FF%
                CLOSE #FF%
                ON ERROR GOTO 0
                FileExists=FilErrFlg
END FUNCTION  